//------------------------------------------------------
// module  : FunctionMCDRIF.cc
// auteur  : Mignotte Max et Redha Touati
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionMCDRIF.h"
#include "FunctionMCDRIF2.h"
#include "MCDRIF.h"

//-------------------------//
//-- Matrice de Flottant --//
//-------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(long int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de int
//----------------------------------------------------------
int**** imatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  int**** matrix;

  matrix=new int***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=imatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de int
//----------------------------------------------------------
void free_imatrix_4d(int**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_imatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float*** mat1,float** mat2,int lgth,int wdth)
{
  int i,j,k;

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[k][i][j]=mat2[i][j]; 
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(int** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 if (max) mat[i][j]=(int)((float)mat[i][j]*((float)GREY_LEVEL/(float)max));      
}

//----------------------------------------------------------
// RecalImgWithSat
//----------------------------------------------------------
void RecalImgWithSat(float** Img,int lgth,int wdth,float pourc)
{
 int i,j,k;
 float min,max;
 int minGL,maxGL;
 const int NBGREYLEVELS=256;
  
 //>Presentation
 //printf("\n > RecalImgWithSat_[%.0f/100]",pourc*100);
 //fflush(stdout);

 //>AllocateMemory
 float** ImgTmp=fmatrix_allocate_2d(lgth,wdth);
 float* VctHist=fmatrix_allocate_1d(NBGREYLEVELS);

 //>Histo[Img]
 for(k=0;k<NBGREYLEVELS;k++)  VctHist[k]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) VctHist[(int)Img[i][j]]++;
 for(k=0;k<NBGREYLEVELS;k++) VctHist[k]/=(lgth*wdth);

 //>SeekMinMax_For_SaturatedPixels
 min=0.0;
 for(k=0;k<NBGREYLEVELS;k++)
    { min+=VctHist[k];
      if (min>pourc) break; }
 minGL=k;

 max=0.0;
 for(k=(NBGREYLEVELS-1);k>0;k--)
    { max+=VctHist[k];
      if (max>pourc) break; }
 maxGL=k;

 //printf("_[min/max>%d::%d]",minGL,maxGL);
 //fflush(stdout);

 //>Recal_Between_[minG:maxGL]
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (Img[i][j]<=minGL) Img[i][j]=0;
      if (Img[i][j]>=maxGL) Img[i][j]=maxGL; }
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Img[i][j]=255.0*((Img[i][j]-minGL)/(maxGL-minGL));
 
 //>Verif
 minGL=(NBGREYLEVELS-1);
 maxGL=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (Img[i][j]<minGL) minGL=Img[i][j];
      if (Img[i][j]>maxGL) maxGL=Img[i][j]; }
 //printf("_[min/max>%d::%d]",minGL,maxGL);
 //fflush(stdout);
 
 //>FreeMemory
 if (ImgTmp)  free_fmatrix_2d(ImgTmp);
 if (VctHist) free_fmatrix_1d(VctHist);  //>BUG????
}

//----------------------------------------------------------
// Calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
int DiffMatNb(float** pmatl1,float** pmatl2,int lgth,int wdth)
{
 int i,j;
 int chg;

 //>Compte NbChgt
 chg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (pmatl1[i][j]!=pmatl2[i][j]) chg++; 
       
 return chg;
}

//----------------------------------------------------------
// DiffBetween
//----------------------------------------------------------
float DiffBetween(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 float nb=0;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (ImgSegWB[i][j]*ImgGtrWB[i][j]) nb++;
      if ((ImgSegWB[i][j]==0)&&(ImgGtrWB[i][j]==0)) nb++; }

 nb=100*(nb/(lgth*wdth));
 return nb;
}

//----------------------------------------------------------
// Diff_Abs:: ImgR=|Img1-Img2| 
//----------------------------------------------------------
void DiffAbs(float** Img1,float** Img2,float** ImgR,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgR[i][j]=fabs(Img1[i][j]-Img2[i][j]);
}

//----------------------------------------------------------
// Diff_Abs:: ImgR=|Img1-Img2| 
//----------------------------------------------------------
void DiffAbs(float** Img1,float** Img2,float** ImgR,int lgth,int wdth,int HalfSzWnd)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  ImgR[i][j]=0.0;
 for(i=HalfSzWnd;i<(lgth-HalfSzWnd);i++) for(j=HalfSzWnd;j<(wdth-HalfSzWnd);j++) ImgR[i][j]=fabs(Img1[i][j]-Img2[i][j]);
}

//----------------------------------------------------------
// Diff_Sqr:: ImgR=(Img1-Img2)^2
//----------------------------------------------------------
void DiffSqr(float** Img1,float** Img2,float** ImgR,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgR[i][j]=CARRE(Img1[i][j]-Img2[i][j]);
}

//----------------------------------------------------------
// Diff_Sqr:: ImgR=(Img1-Img2)^2
//----------------------------------------------------------
void DiffSqrt(float** Img1,float** Img2,float** ImgR,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgR[i][j]=sqrt(fabs(Img1[i][j]-Img2[i][j]));
}

//----------------------------------------------------------
// RatioLog
//----------------------------------------------------------
void RatioLog(float** Img1,float** Img2,float** ImgR,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {  ImgR[i][j]=((Img2[i][j]+1.0)/(Img1[i][j]+1.0));
       if (ImgR[i][j]<1.0) ImgR[i][j]=((Img1[i][j]+1.0)/(Img2[i][j]+1.0)); }

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgR[i][j]*=100;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (ImgR[i][j]>255) ImgR[i][j]=255;
}

//----------------------------------------------------------
// InitZero
//----------------------------------------------------------
void InitZero(float** Mat,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  Mat[i][j]=0.0;
}

//----------------------------------------------------------
// InitZero
//----------------------------------------------------------
void InitZero(float*** Mat,int Nb,int lgth,int wdth)
{
 int i,j,k;
 for(k=0;k<Nb;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  Mat[k][i][j]=0.0;
}

//----------------------------------------------------------
// InitOne
//----------------------------------------------------------
void InitOne(float** Mat,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  Mat[i][j]=255.0;
}

//----------------------------------------------------------
// AddToMatrix
//----------------------------------------------------------
void AddToMatrix(float** MatAcc,float** Mat,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatAcc[i][j]+=Mat[i][j];
}

//----------------------------------------------------------
// AddToMatrixMax
//----------------------------------------------------------
void AddToMatrixMax(float** MatAcc,float*** Mat,int lgth,int wdth)
{
 int i,j;
 float max1,max2;
 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {
      if (Mat[0][i][j]>Mat[1][i][j])  max1=Mat[0][i][j];
      else max1=Mat[1][i][j];

      if (max1>Mat[2][i][j])  max2=max1;
      else max2=Mat[2][i][j];
      
      MatAcc[i][j]+=max2;
    }
}

//----------------------------------------------------------
// NegateMatrix
//----------------------------------------------------------
void NegateMatrix(float** Mat,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  Mat[i][j]=255-Mat[i][j];
}

//----------------------------------------------------------
// NegateLabelMatrix
//----------------------------------------------------------
void NegateLabelMatrix(float** Mat,int lgth,int wdth)
{
 int i,j;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (Mat[i][j]) Mat[i][j]=0.0;
      else Mat[i][j]=1.0; }		 
}

//----------------------------------------------------------
// InvBlackWhiteLabelMat
//----------------------------------------------------------
void InvBlackWhiteLabelMat(float** MatSeg,int lgth,int wdth)
{
 int i,j;
 int NbWhiteLabels;

 NbWhiteLabels=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatSeg[i][j]) NbWhiteLabels++;
 if (NbWhiteLabels>((lgth*wdth)/2))
    { printf("\n > INVERSION");
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
         { if (MatSeg[i][j]==0) MatSeg[i][j]=1;
           else MatSeg[i][j]=0; } }
}

//----------------------------------------------------------
// MeanMatrix
//----------------------------------------------------------
void MeanMatrix(float*** VctMatrix,int lgth,int wdth,int nb,float** MeanMatrix)
{
 int i,j,k;
 float tmp;

 //>MainLoop
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { tmp=0.0;
      for(k=0;k<nb;k++) tmp+=VctMatrix[k][i][j];
      tmp/=(nb);
      MeanMatrix[i][j]=tmp; }
}

//----------------------------------------------------------
// VisuMatrix
//----------------------------------------------------------
void VisuMatrix(float** Matrix,int lgth,int wdth)
{
  int m,n;

 printf("\n");
 for(m=0;m<lgth;m++)
    { printf("\n");
      for(n=0;n<wdth;n++) printf("[%.2f]",Matrix[m][n]); }
 printf("\n");
}

//----------------------------------------------------------
// VisuMatrixMatlab
//----------------------------------------------------------
void VisuMatrixMatlab(float** Matrix,int lgth,int wdth)
{
 float m,n;

 printf("\n\n\n");
 for(m=0;m<lgth;m++) for(n=0;n<wdth;n++) printf("\n %.5f %.5f %.5f",m,n,Matrix[(int)m][(int)n]); 
 printf("\n\n\n");
}

//----------------------------------------------------------
// InfoStatMat
//----------------------------------------------------------
void InfoStatMat(float** Mat,int lgth,int wdth)
{
 int i,j;
 int NbOutPos,NbOutNeg;

 NbOutPos=NbOutNeg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (Mat[i][j]<0)   NbOutNeg++;
      if (Mat[i][j]>255) NbOutPos++;  }

 printf("\nSTAT-MAT: NbOutliers[Neg::%d][Pos::%d][%d]\n",NbOutNeg,NbOutPos,lgth*wdth);
}

//----------------------------------------------------------
// InfoStatConv
//----------------------------------------------------------
void InfoStatConv(float** Mat,int lgth,int wdth)
{
 int i,j;
 float Sum;

 Sum=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Sum+=Mat[i][j];
 printf("\nSTAT-CONV: Sum=[%.3f]",Sum);
}

//----------------------------------------------------------
// SelectBand
//----------------------------------------------------------
void SelectBand(float*** MatRVB,int lgth,int wdth,float** MatBW)
{
 int i,j;
 int flag;
 float mean0,mean1,mean2;
 float var0,var1,var2;

 mean0=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mean0+=MatRVB[0][i][j];
 mean0/=(lgth*wdth);
 var0=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) var0+=CARRE(MatRVB[0][i][j]-mean0);
 var0/=(lgth*wdth);
 
 mean1=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mean1+=MatRVB[1][i][j];
 mean1/=(lgth*wdth);
 var1=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) var1+=CARRE(MatRVB[1][i][j]-mean1);
 var1/=(lgth*wdth);

 mean2=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mean2+=MatRVB[2][i][j];
 mean2/=(lgth*wdth);
 var2=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) var2+=CARRE(MatRVB[2][i][j]-mean2);
 var2/=(lgth*wdth);
 
 printf(" STATS-COUL>WB:[%.1f][%.1f][%.1f]",var0,var1,var2);
 flag=-1;
 if ((var0>=var1)&&(var0>=var2)) flag=0;
 if ((var1>=var0)&&(var1>=var2)) flag=1;
 if ((var2>=var0)&&(var2>=var1)) flag=2;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatBW[i][j]=MatRVB[flag][i][j];  
}

//--------------//
// RANDOM ------//
//--------------//
//----------------------------------------------------------
// Nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }

//----------------------------------------------------------
// Nombre aleatoire entier entre zero et un
//----------------------------------------------------------
int RandIntBetween(int min,int max)
{
 float scale=max-min;
 float val=min+(scale*randomize())+0.5;
 return (int)val;
}

//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;
  if (0) printf("[%d][%c]",temp,*tempc);

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// load ppm image 
//----------------------------------------------------------
void LoadImagePpm(char* path,float*** data,int length,int width)
 {
  int i,j;
  int   temp;
  char* tempc;
  unsigned char varr,varb,varv;  
  char header[100];
  char* ptr;
  int ta1,ta2,ta3;
  FILE *fic;

  //Open file
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n -> Grave erreur a l'ouverture de %s !\n",path);
      exit(-1); }

  tempc=fgets(header,100,fic);
  if ( (header[0]!=80) ||    /* 'P' */
       (header[1]!=54) ) {   /* '6' */
       fprintf(stderr,"Image %s is not PPM.\n",path);
       exit(1); }

  tempc=fgets(header,100,fic);
  while(header[0]=='#') tempc=fgets(header,100,fic);
 
  ta1=strtol(header,&ptr,0);
  ta2=atoi(ptr);
  tempc=fgets(header,100,fic);
  ta3=strtol(header,&ptr,0);
    
  //Load
  for(i=0;i<length;i++) for(j=0;j<(width*3);j+=3)  
      {
       temp=fread(&varr,1,1,fic);
       temp=fread(&varv,1,1,fic);
       temp=fread(&varb,1,1,fic);    
       data[0][i][j/3]=varr;        
       data[1][i][j/3]=varv;        
       data[2][i][j/3]=varb;
      }

  //Close file
  if (0) printf("[%d][%s][%d:%d:%d]",temp,tempc,ta1,ta2,ta3);
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,int** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
    printf("\n >> Sauvegarde dans -> %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
    printf("\n >> Sauvegarde dans -> %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int lgth,int wdth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");
  //if (strstr(buff,".ppm")==NULL) strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n sauvegarde dans -> %s au format %s [%d][%d]",buff,".ppm",wdth,lgth);
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//---------------------
//---------------------
//---REDUCTION SIZE----
//---------------------
//---------------------
//----------------------------------------------------------
// multiresolution
//----------------------------------------------------------
void Multires(float** MatIn,int lgth,int wdth,float** MatOut,int scale)
{ 
 int i,j,ii,jj;
 int row,col;
 float sum_pix;
 int cpt;
 int lgthR,wdthR;
 lgthR=lgth/scale;
 wdthR=wdth/scale;
 //printf("\n [scale::%d]  [%d::%d > %d::%d] \n",scale,lgth,wdth,lgthR,wdthR);
 //fflush(stdout);

  //Loop
 if (scale>1)
 for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    {  row=(int)(i*scale);
       col=(int)(j*scale);
       sum_pix=0.0;  
       cpt=0;
       for(ii=row;ii<(row+scale);ii++) for(jj=col;jj<(col+scale);jj++)
	  { sum_pix+=MatIn[ii][jj];  cpt++; }	            
       if (cpt!=0) sum_pix/=cpt;    
       if ((i<lgthR)&&(j<wdthR)) MatOut[i][j]=(int)(sum_pix+0.5); }

 if (scale==1) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++) MatOut[i][j]=MatIn[i][j];
}

//----------------------------------------------------------
// multiresolution
//----------------------------------------------------------
void Multires(int** MatIn,int lgth,int wdth,int** MatOut,int scale)
{ 
 int i,j,ii,jj;
 int row,col;
 float sum_pix;
 int cpt;
 int lgthR,wdthR;
 lgthR=lgth/scale;
 wdthR=wdth/scale;

  //Loop
 for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    {  row=(int)(i*scale);
       col=(int)(j*scale);
       sum_pix=0.0;  
       cpt=0;
       for(ii=row;ii<(row+scale);ii++) for(jj=col;jj<(col+scale);jj++)
	  { sum_pix+=MatIn[ii][jj];  cpt++; }	            
       if (cpt!=0) sum_pix/=cpt;    
       if ((i<lgthR)&&(j<wdthR)) MatOut[i][j]=(int)(sum_pix+0.5); }
}

//----------------------------------------------------------
// DecreasedSize
//----------------------------------------------------------
void DecreasedSize(float*** ImgB,float*** ImgA,float*** ImgG,int* lgth,int* wdth,int* scale)
{
 int i,j,k;
 int ScaleFactor;
 int length,width;
 int lgthR,wdthR;

 length=(*lgth);
 width=(*wdth);
 ScaleFactor=(int)(MAX(length,width)/MAXLGTHIMG);
 //printf(" [%d:%d]:Scale=%d",length,width,ScaleFactor);
 //fflush(stdout);
 lgthR=length/ScaleFactor;
 wdthR=width/ScaleFactor;

  //>AllocationMemory
 float*** MatImgB=fmatrix_allocate_3d(TROIS,lgthR,wdthR);
 float*** MatImgA=fmatrix_allocate_3d(TROIS,lgthR,wdthR);	
 float*** MatImgG=fmatrix_allocate_3d(TROIS,lgthR,wdthR);

 //>Reduction_[Before-After]-[GroundTruth]
 Multires(ImgB[0],length,width,MatImgB[0],ScaleFactor);
 Multires(ImgA[0],length,width,MatImgA[0],ScaleFactor);
 Multires(ImgB[1],length,width,MatImgB[1],ScaleFactor);
 Multires(ImgA[1],length,width,MatImgA[1],ScaleFactor);
 Multires(ImgB[2],length,width,MatImgB[2],ScaleFactor);
 Multires(ImgA[2],length,width,MatImgA[2],ScaleFactor);

 Multires(ImgG[0],length,width,MatImgG[0],ScaleFactor);
 Multires(ImgG[1],length,width,MatImgG[1],ScaleFactor);
 Multires(ImgG[2],length,width,MatImgG[2],ScaleFactor);

 //>Binarisation-[GroundTruth]
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { if (MatImgG[k][i][j]<128) MatImgG[k][i][j]=0;
      else MatImgG[k][i][j]=255; }

 //>In_PPM
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { ImgB[k][i][j]=MatImgB[k][i][j];
      ImgA[k][i][j]=MatImgA[k][i][j];
      ImgG[k][i][j]=MatImgG[k][i][j]; }	

 //>DEBUG
 //SaveImagePpm((char*)"",(char*)"PictB",ImgB,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictA",ImgA,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictG",ImgG,lgthR,wdthR);
 //exit(-1);
 
 //>End
 if (MatImgB) free_fmatrix_3d(MatImgB,TROIS);
 if (MatImgA) free_fmatrix_3d(MatImgA,TROIS);
 if (MatImgG) free_fmatrix_3d(MatImgG,TROIS);
 (*lgth)=lgthR;
 (*wdth)=wdthR;
 (*scale)=ScaleFactor;
}

//----------------------------------------------------------
// DecreasedSizeByTwo
//----------------------------------------------------------
void DecreasedSizeByTwo(float*** ImgB,float*** ImgA,float*** ImgG,int* lgth,int* wdth,int* scale)
{
 int i,j,k;
 int ScaleFactor;
 int length,width;
 int lgthR,wdthR;

 printf(" > DecreasedSizeByTwo");
 length=(*lgth);
 width=(*wdth);
 ScaleFactor=2;
 //printf(" [%d:%d]:Scale=%d",length,width,ScaleFactor);
 //fflush(stdout);
 lgthR=length/ScaleFactor;
 wdthR=width/ScaleFactor;

  //>AllocationMemory
 float*** MatImgB=fmatrix_allocate_3d(TROIS,lgthR,wdthR);
 float*** MatImgA=fmatrix_allocate_3d(TROIS,lgthR,wdthR);	
 float*** MatImgG=fmatrix_allocate_3d(TROIS,lgthR,wdthR);

 //>Reduction_[Before-After]-[GroundTruth]
 Multires(ImgB[0],length,width,MatImgB[0],ScaleFactor);
 Multires(ImgA[0],length,width,MatImgA[0],ScaleFactor);
 Multires(ImgB[1],length,width,MatImgB[1],ScaleFactor);
 Multires(ImgA[1],length,width,MatImgA[1],ScaleFactor);
 Multires(ImgB[2],length,width,MatImgB[2],ScaleFactor);
 Multires(ImgA[2],length,width,MatImgA[2],ScaleFactor);

 Multires(ImgG[0],length,width,MatImgG[0],ScaleFactor);
 Multires(ImgG[1],length,width,MatImgG[1],ScaleFactor);
 Multires(ImgG[2],length,width,MatImgG[2],ScaleFactor);

 //>Binarisation-[GroundTruth]
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { if (MatImgG[k][i][j]<128) MatImgG[k][i][j]=0;
      else MatImgG[k][i][j]=255; }

 //>In_PPM
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { ImgB[k][i][j]=MatImgB[k][i][j];
      ImgA[k][i][j]=MatImgA[k][i][j];
      ImgG[k][i][j]=MatImgG[k][i][j]; }	

 //>DEBUG
 //SaveImagePpm((char*)"",(char*)"PictB",ImgB,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictA",ImgA,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictG",ImgG,lgthR,wdthR);
 //exit(-1);
 
 //>End
 if (MatImgB) free_fmatrix_3d(MatImgB,TROIS);
 if (MatImgA) free_fmatrix_3d(MatImgA,TROIS);
 if (MatImgG) free_fmatrix_3d(MatImgG,TROIS);
 (*lgth)=lgthR;
 (*wdth)=wdthR;
 (*scale)=(*scale)*ScaleFactor;
}

//----------------------------------------------------
// Interpolation bilineaire                           
//----------------------------------------------------
void InterpolBilineaire(int** imgIn,int** imgOut,int lgth,int wdth,float sc)  
{
 int i,j;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;
 float scale;

 //>MainLoop
 scale=(1.0/(float)sc);
 for(i=0;i<(scale*lgth);i++) for(j=0;j<(scale*wdth);j++)
     {
      col=(float)j/(float)scale;
      row=(float)i/(float)scale;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1))  col_sup-=wdth;
      if (row_sup>(lgth-1))  row_sup-=lgth;

      t=(col-col_inf)/(col_sup-col_inf);
      u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[row_inf][col_inf];
      ng+=t*(1-u)*imgIn[row_inf][col_sup];
      ng+=t*u*imgIn[row_sup][col_sup];
      ng+=(1-t)*u*imgIn[row_sup][col_inf];
      imgOut[i][j]=(int)ng;   
     }
}

//----------------------------------------------------
// Interpolation bilineaire
//    [imgIn] > [imgOut] (1/sc)(lgth) (1/sc)(wdth)
//----------------------------------------------------
void InterpolBilineaire(float** imgIn,float** imgOut,int lgth,int wdth,float sc)  
{
 int i,j;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;
 float scale;

 //>MainLoop
 scale=(1.0/(float)sc);
 for(i=0;i<(scale*lgth);i++) for(j=0;j<(scale*wdth);j++)
     {
      col=(float)j/(float)scale;
      row=(float)i/(float)scale;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1))  col_sup-=wdth;
      if (row_sup>(lgth-1))  row_sup-=lgth;

      t=(col-col_inf)/(col_sup-col_inf);
      u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[row_inf][col_inf];
      ng+=t*(1-u)*imgIn[row_inf][col_sup];
      ng+=t*u*imgIn[row_sup][col_sup];
      ng+=(1-t)*u*imgIn[row_sup][col_inf];
      imgOut[i][j]=(int)ng;   
     }
}

//-----------------//
//-- HISTO MANIP --//
//-----------------//
//-----------------------------------------------------
// calcul de l'histogramme                           
//-----------------------------------------------------
void Compute_histo(float** img,int lgth,int wdth,float* hist)
{
 int i,j;

  //initialisation
  for(i=0;i<GREY_LEVEL;i++) hist[i]=0.0;

  //calcul de l'histogramme
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if ((img[i][j]>0)&&(img[i][j]<GREY_LEVEL))
       hist[(int)(img[i][j]+0.5)]++;
 
  //normalisation
  for(i=0;i<GREY_LEVEL;i++)  hist[i]/=(float)(wdth*lgth);
}

//------------------------------------------------
// Specif. histo[img_in] sur histo[img_out]
// (img_in possédant le même histo que img_out)
//------------------------------------------------
void SpecifHisto(float** img_in,int lgth_in,int wdth_in,float** img_out,int lgth_out,int wdth_out)
 {
  int i,j;
  float Hist_Img1[GREY_LEVEL+1],Hist_Img2[GREY_LEVEL+1];
  float Vect_Img1[GREY_LEVEL+1],Vect_Img2[GREY_LEVEL+1],Vect_Img3[GREY_LEVEL+1];

  //--------Egalisation------------
  //Initialisation
  for(i=0;i<=GREY_LEVEL;i++)
    { Hist_Img1[i]=Hist_Img2[i]=0.0;
      Vect_Img1[i]=Vect_Img2[i]=Vect_Img3[i]=0.0; }

  //Calcule histo[img_in]
  Compute_histo(img_in,lgth_in,wdth_in,Hist_Img1);

  //Calcule T::fonctRepartition[img_in]>Vect_Img1
  for(i=0;i<=GREY_LEVEL;i++)
    { if (i>0)  Vect_Img1[i]=Vect_Img1[i-1]+Hist_Img1[i];
      else      Vect_Img1[i]=Vect_Img1[i]; }
  for(i=0;i<=GREY_LEVEL;i++) Vect_Img1[i]=(int)((Vect_Img1[i]*255)+0.5);

  //Egalise histo[img_in]
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++)
     img_in[i][j]=(int)Vect_Img1[(int)(img_in[i][j])];

  //========================

  //Calcule histo[img_out]
  Compute_histo(img_out,lgth_out,wdth_out,Hist_Img2);

  //Calcule G::fonctRepartition[img_out]>Vect_Img2
  for(i=0;i<=GREY_LEVEL;i++)
    { if (i>0)  Vect_Img2[i]=Vect_Img2[i-1]+Hist_Img2[i];
      else      Vect_Img2[i]=Vect_Img2[i]; }
  for(i=0;i<=GREY_LEVEL;i++) Vect_Img2[i]=(int)((Vect_Img2[i]*255)+0.5);

  //Calcule G^-1 (avec G=Vect_Img2)>Vect_Img3
  for(i=0;i<=GREY_LEVEL;i++)
    { Vect_Img3[i]=i;
      for(j=GREY_LEVEL;j>0;j--) if (Vect_Img2[j]>i) Vect_Img3[i]=j; }

  //Specif. histo[img_in]>histo[img_out]
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++)
  if ((int)(img_in[i][j])<(GREY_LEVEL+1)) img_in[i][j]=(int)Vect_Img3[(int)(img_in[i][j])];

  //Verif-
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++) if (img_in[i][j]>255) img_in[i][j]=255;
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++) if (img_in[i][j]<0)   img_in[i][j]=0;
 }

//------------------------------------------------
// Double Specif. histo [img_in::img_out]
//------------------------------------------------
void DoubleSpecifHisto(float** img1,float** img2,int lgth,int wdth)
{
 //>DoubleHistoSpecif
 SpecifHisto(img1,lgth,wdth,img2,lgth,wdth);
 SpecifHisto(img2,lgth,wdth,img1,lgth,wdth);
}

//------------------------------------------------
// RecalMoy [img1::img2]
//------------------------------------------------
void RecalMoy(float** img1,float** img2,int lgth,int wdth)
{
 int i,j;
 float Moy1,Moy2;
 int DEBUG_=0;

 Moy1=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy1+=img1[i][j];
 Moy1/=(lgth*wdth);
 Moy2=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy2+=img2[i][j];
 Moy2/=(lgth*wdth);
 if (DEBUG_) printf("[%.2f::%2f]>",Moy1,Moy2);

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  img1[i][j]+=(Moy2-Moy1);
 Moy1=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy1+=img1[i][j];
 Moy1/=(lgth*wdth);
 if (DEBUG_) printf("[%.2f::%.2f]",Moy1,Moy2);
}

//----------------------------------------------------------
// Rempli une matrice (carree) ImgHist de
// l'histogramme de MatObs
// et du mélange de distribution (2 lois Gauss)
//----------------------------------------------------------
void FillPictHist(float** ImgHist,int SzImgHist,float** MatObs,int lgth,int wdth,float** ParExpDistMixt)
{
 int i,j,c,p;
 int k;
 int row,col;
 double FctStrchLgthHist;
 float tmp,tp;
 const int MAXGREYLEVEL=256;

 //Presentation
 printf("\n > FillPictHist");
 fflush(stdout);

 //AllocateMemory_Initialization
 for(i=0;i<SzImgHist;i++) for(j=0;j<SzImgHist;j++) ImgHist[i][j]=GREY_LEVEL;
 float* VctHist=fmatrix_allocate_1d(MAXGREYLEVEL);
 for(k=0;k<MAXGREYLEVEL;k++) VctHist[k]=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) VctHist[(int)(MatObs[i][j]+0.5)]++;
 for(k=0;k<MAXGREYLEVEL;k++) VctHist[k]/=(lgth*wdth);
 FctStrchLgthHist=6000.0;  //--HERE !!!!

 //Draw_Img_Histogram
 for(p=0;p<MAXGREYLEVEL;p++)
   { tmp=(int)(VctHist[p]*FctStrchLgthHist); 
     if (tmp>=SzImgHist) tmp=(SzImgHist-1);
     for(tp=tmp;tp>0;tp--) 
        {  row=SzImgHist-tp;
           col=p;
	   ImgHist[row][col]=(GREY_LEVEL/2); } }

 //Draw_Mixture_Two_Gaussians
 float pp;
 for(c=0;c<2;c++)
    { for(pp=0;pp<MAXGREYLEVEL;pp+=0.1)
	 { tmp=FctStrchLgthHist*funcgauss((float)pp,ParExpDistMixt[c][0],ParExpDistMixt[c][1],ParExpDistMixt[c][2]);
           if (tmp>=SzImgHist) tmp=(SzImgHist-1);
           row=SzImgHist-tmp;
           col=pp;
	   if (row<SzImgHist) ImgHist[row][col]=0; } }

 //>Free_Memory
 if (VctHist) free_fmatrix_1d(VctHist);
}

//----------------------------------------------------------
// function Normal
//----------------------------------------------------------
float funcgauss(float val,float coef,float moy,float var)
{
 return ((coef)*(1/(sqrt(2*PI*var)))*exp(-1*(CARRE(val-moy)/(2*var))));
}


//-----------//
//--RESULTS--//
//-----------//
//----------------------------------------------------------
// ConfusionMatrix
//----------------------------------------------------------
void ConfusionMatrix(float*** ImgCon,float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth,float* Res)
{
 int i,j;
 long int TN,TP,FP,FN;
 float pTN,pTP,pFP,pFN;
 float Prec;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=FP=FN=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j]))
        { ImgCon[0][i][j]=255;
	  ImgCon[1][i][j]=255;
	  ImgCon[2][i][j]=255;
	  TN++; }

     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j]))
        { ImgCon[0][i][j]=255;
	  ImgCon[1][i][j]=0;
	  ImgCon[2][i][j]=0;
	  TP++; }

     //>--FP--
     if ((!ImgGtrWB[i][j])&&(ImgSegWB[i][j]))
        { ImgCon[0][i][j]=0;
	  ImgCon[1][i][j]=0;
	  ImgCon[2][i][j]=255;
	  FP++; }

     //>--FN--
     if ((ImgGtrWB[i][j])&&(!ImgSegWB[i][j]))
        { ImgCon[0][i][j]=0;
	  ImgCon[1][i][j]=255;
	  ImgCon[2][i][j]=255;
	  FN++; } }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 pFP=100.0*(float)FP/(float)NbPix;
 pFN=100.0*(float)FN/(float)NbPix;
 Res[0]=pTN;
 Res[1]=pTP;
 Res[2]=pFP;
 Res[3]=pFN;
 Prec=pTN+pTP;
 printf("\n > [TN=%.3f][TP=%.3f][FP=%.3f][FN=%.3f]>>[%.5f]",pTN,pTP,pFP,pFN,Prec);
 fflush(stdout);
}

//----------------------------------------------------------
// F-Measure
//----------------------------------------------------------
float FMeasure(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 long int TN,TP,FP,FN;
 float pTN,pTP,pFP,pFN;
 float Prec;
 float Precision,Recall,FMeasure;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=FP=FN=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) TN++;
     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j])) TP++;
     //>--FP--
     if ((!ImgGtrWB[i][j])&&(ImgSegWB[i][j])) FP++;
     //>--FN--
     if ((ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) FN++;  }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 pFP=100.0*(float)FP/(float)NbPix;
 pFN=100.0*(float)FN/(float)NbPix;
 Prec=pTN+pTP;
 if (0) printf("\n > [TN=%.3f][TP=%.3f][FP=%.3f][FN=%.3f]>>[%.5f]",pTN,pTP,pFP,pFN,Prec);
 Precision=(float)TP/((float)TP+(float)FP);
 Recall=(float)TP/((float)TP+(float)FN);
 FMeasure=(2*Precision*Recall)/(Precision+Recall);
 if ((TP==0)&&(FP==0)) { FMeasure=0.0; printf("**********"); }
 if (TP==0) FMeasure=0.0;
 printf("\n > [Precision=%.3f][Recall=%.3f]>>[Fmeasure=%.3f]",Precision,Recall,FMeasure);
 fflush(stdout);
 return FMeasure;
}

//----------------------------------------------------------
// Precision
//----------------------------------------------------------
float Precis(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 long int TN,TP;
 float pTN,pTP;
 float Precision;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) TN++;
     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j])) TP++;  }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 Precision=pTN+pTP;
 printf(" [Precision=%.3f]",Precision);
 fflush(stdout);
 return Precision;
}

//------------//
//-- GESTION--//
//------------//
//----------------------------------------------------------
// AbsDiff      
//----------------------------------------------------------
void AbsDiff(float** MatAft,float** MatTmp1,float** MatTmp2,int lgth,int wdth)
{
 int i,j;

 //>Loop
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 MatTmp2[i][j]=fabs(MatAft[i][j]-MatTmp1[i][j]);
}

//----------------------------------------------------------
// Diff      
//----------------------------------------------------------
void Diff(float** MatAft,float** MatTmp1,float** MatTmp2,int lgth,int wdth)
{
 int i,j;

 //>Loop
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 MatTmp2[i][j]=(MatAft[i][j]-MatTmp1[i][j]);
}

//----------------------------------------------------------
// MedianFilter     
//----------------------------------------------------------
void MedianFilter(int*** VctWin,int Knn,int Lgth,int Wdth,int** WinOut)
{
 int i,j,k;
  
 //>AllocateMemory
 int* Vct=imatrix_allocate_1d(Knn);

 //>MainLoop
 for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++)
    { for(k=0;k<Knn;k++) Vct[k]=VctWin[k][i][j];
      InsertionSort(Vct,Knn);
      WinOut[i][j]=Vct[Knn/2]; }

 //>FreeMemory
 if (Vct) free_imatrix_1d(Vct);
}

//----------------------------------------------------------
// Insertion_sort 
//----------------------------------------------------------
void InsertionSort(int* a,int size)
{
 int i,j,k;
 for (i=1;i<size;++i)
     { 
      k=a[i];
      j=i-1;
      while ((j>=0)&&(k<a[j]))
        { a[j + 1] = a[j];
          --j; }
        a[j+1]=k;
     }
}

//----------------------------------------------------------
// MeanFilter     
//----------------------------------------------------------
void MeanFilter(int*** VctWin,int Knn,int Lgth,int Wdth,int** WinOut)
{
 int i,j,k;
 float sum;
  
 //>MainLoop
 for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++)
    { sum=0.0;
      for(k=0;k<Knn;k++) sum+=VctWin[k][i][j];
      sum=sum/Knn;
      WinOut[i][j]=(int)(sum+0.5); }
}

//----------------------------------------------------------
// Grad
//----------------------------------------------------------     
void Grad(float** MatIn,int lgth,int wdth)
 { 
  int i,j;
  float tmp,max;

  //AllocMemoire
  float** MatGrd=fmatrix_allocate_2d(lgth,wdth);

  //>Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatGrd[i][j]=0.0;

  //>Gradient
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { tmp=CARRE(MatIn[i+1][j]-MatIn[i-1][j])+CARRE(MatIn[i][j+1]-MatIn[i][j-1]);  
       tmp=sqrt(tmp); 
       MatGrd[i][j]=tmp; }
     
  //>Normalize
  max=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) { if (MatGrd[i][j]>max) max=MatGrd[i][j]; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatGrd[i][j]=((MatGrd[i][j]*255.0)/max);
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatIn[i][j]=MatGrd[i][j];

  //Liberation Memoire
  if (MatGrd) free_fmatrix_2d(MatGrd);
 }

//----------------------------------------------------------
// LogGrad
//----------------------------------------------------------     
void LogGrad(float** MatIn,int lgth,int wdth)
{
 Grad(MatIn,lgth,wdth);
 for(int i=0;i<lgth;i++) for(int j=0;j<wdth;j++) MatIn[i][j]=log(1.0+MatIn[i][j]);
 Recal(MatIn,lgth,wdth);
}
  

//----------------------------------------------------------
// FctLog
//----------------------------------------------------------     
void FctLog(float** MatIn,int lgth,int wdth)
 { 
  int i,j;
  float max;

  //AllocMemoire
  float** MatLog=fmatrix_allocate_2d(lgth,wdth);

  //>Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatLog[i][j]=0.0;

  //>Gradient
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatLog[i][j]=log(1+MatIn[i][j]);
     
  //>Normalize
  max=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) { if (MatLog[i][j]>max) max=MatLog[i][j]; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatLog[i][j]=((MatLog[i][j]*255.0)/max);
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatIn[i][j]=MatLog[i][j];

  //Liberation Memoire
  if (MatLog) free_fmatrix_2d(MatLog);
 }

//----------------------------------------------------------
// EdgeBooster
//----------------------------------------------------------     
void EdgeBooster(float** MatIn,int lgth,int wdth,float kk)
 { 
  int i,j;
  float sum,tmp,max;

  //AllocMemoire_&_Init
  float** MatTmp=fmatrix_allocate_2d(lgth,wdth);
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatTmp[i][j]=0.0;

  //>Gradient
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { sum=0.0;
       sum=4*MatIn[i][j];
       sum+=2*MatIn[i-1][j];
       sum+=2*MatIn[i+1][j];
       sum+=2*MatIn[i][j-1]; 
       sum+=2*MatIn[i][j+1]; 
       sum+=1*MatIn[i+1][j+1]; 
       sum+=1*MatIn[i-1][j-1];
       sum+=1*MatIn[i-1][j+1];
       sum+=1*MatIn[i+1][j-1]; 
       sum/=16.0;
       sum+=0.5;
       tmp=(kk*MatIn[i][j]-sum);
       MatTmp[i][j]=(int)(tmp); }

  //>Check
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { if (MatTmp[i][j]<0) MatTmp[i][j]=0;
       if (MatTmp[i][j]>255) MatTmp[i][j]=255;	}	  
     
  //>Normalize
  max=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) { if (MatTmp[i][j]>max) max=MatTmp[i][j]; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatTmp[i][j]=((MatTmp[i][j]*255.0)/max);
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)   MatIn[i][j]=MatTmp[i][j];

  //Liberation Memoire
  if (MatTmp) free_fmatrix_2d(MatTmp);
 }

//----------------------------------------------------------
// GaussianFilter
//----------------------------------------------------------
void GaussianFilter(float** mt,int lgth,int wdth,int Nb) 
{
 int i,j,k;
 float tmp;

 //MemoryAllocation
 float** mat_tmp=fmatrix_allocate_2d(lgth,wdth);

 //Filtre Gaussian
 for(k=0;k<Nb;k++)
   {
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=mt[i][j];
 
    for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
       { tmp=0.0;
         tmp+=4*mt[i][j];
         tmp+=2*mt[i+1][j]; tmp+=2*mt[i-1][j]; tmp+=2*mt[i][j+1]; tmp+=2*mt[i][j-1];
         tmp+=mt[i+1][j+1]; tmp+=mt[i-1][j-1]; tmp+=mt[i+1][j-1]; tmp+=mt[i-1][j+1];
         tmp/=16.0;
         mat_tmp[i][j]=tmp; }

    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  mt[i][j]=mat_tmp[i][j];
   }

 //Verif
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (mt[i][j]>255) mt[i][j]=255;
      if (mt[i][j]<0)   mt[i][j]=0.0; }

 //FreeMemory
 free_fmatrix_2d(mat_tmp);
}

//----------------------------------------------------------*/
//  MedianFilter                                               
//----------------------------------------------------------*/
void MedianFilter(float** mat,int lgth,int wdth,int size)
{
 int i,j,k,l,m;
 int nb;
 float tmp;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 vect=fmatrix_allocate_1d(size*size);

 //recopie matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat_tmp[i][j]=mat[i][j];

 //Filtre median
 for(i=(size/2);i<(lgth-(size/2));i++) for(j=(size/2);j<(wdth-(size/2));j++)
   {
    nb=0;

    for(k=-(size/2);k<=(size/2);k++) for(l=-(size/2);l<=(size/2);l++)  
        vect[nb++]=mat_tmp[i+k][j+l];

    for(l=0;l<((size*size)-1);l++) for(m=0;m<((size*size)-1);m++)
       if (vect[m]>vect[m+1]) 
	  { tmp=vect[m];
            vect[m]=vect[m+1];
            vect[m+1]=tmp; } 

   mat[i][j]=vect[((size*size)/2)+1]; 
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}

//----------------------------------------------------------
// FilterMat                                              
//----------------------------------------------------------
void FilterMat(int*** MatGaussParam,int lgth,int wdth,int NbMap,int Nb,int Methd)
{
 int i,j,k;

 //>ÀllocMemory_&_Transf
 float** Mat=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Mat[i][j]=MatGaussParam[NbMap][i][j];

 //>Filtering_&_Transf
 if (Methd==0) for(k=0;k<Nb;k++) GaussianFilter(Mat,lgth,wdth,1);
 if (Methd==1) for(k=0;k<Nb;k++) MedianFilter(Mat,lgth,wdth,3);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatGaussParam[NbMap][i][j]=Mat[i][j];

 //>FreeMemory
 free_fmatrix_2d(Mat);
}

//---------------
//---------------
//---K-MEAN------
//---------------
//---------------
//----------------------------------------------------------
// Identical                      
//----------------------------------------------------------
int Identical(float* VctPts,float** MtxCtrs,int nbcl,int nbpar)
{
 int k,l;
 int value=0;

 for(k=0;k<nbcl;k++) 
   { value=1;
     for(l=0;l<nbpar;l++) if (VctPts[l]!=MtxCtrs[k][l]) value=0;
     if (value) return value; }
    
 return value;
}

//----------------------------------------------------------
//  KMean  
//----------------------------------------------------------
void Kmean(float** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,int Verbose)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;
 const int NBITERMAX=10;
 
 //Allocation memoire
 float** MatrixCtrs=fmatrix_allocate_2d(NbClusters,NbParam);
 
 //Presentation
 if (Verbose) printf("\n  <Seed:%d> -> Funct.Kmean",Seed);
 srand(Seed);

 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));
     if ((Verbose)&&(nb>0)) printf("[%d]",nb);
     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
    
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<NBITERMAX;l++)
   {  
       //-[1]- Select_Cluster_Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                         
                //for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);  //A-Tester
                for(k=0;k<NbParam;k++) dist+=abs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>2))  break;
       if (Verbose) { printf("[%d>%d]",l,flag); fflush(stdout); }
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_fmatrix_2d(MatrixCtrs);
}

//----------------------------------------------------------     
// KmeanEstimate
//----------------------------------------------------------     
void KmeanEstimate(float** Img,int lgth,int wdth,int NbLabel,float** VctPar,int Seed,int Verbose)
{
  int i,j;
  const int NbFeat=1;
  float prop0,prop1,mean0,mean1,var0,var1;
 
 //>Init-Memory
 int* VctLabel=imatrix_allocate_1d(lgth*wdth);
 float** VctFeat=fmatrix_allocate_2d(lgth*wdth,NbFeat);
 int**   MatSeg=imatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) VctFeat[(i*wdth)+j][0]=Img[i][j];
 
 //>K-Mean
 printf("\n\n [KMEAN]");
 Kmean(VctFeat,NbLabel,(lgth*wdth),NbFeat,VctLabel,Seed,Verbose);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatSeg[i][j]=VctLabel[(i*wdth)+j];

 //>FillVctPar
 prop0=prop1=0.0;
 mean0=mean1=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {  if (MatSeg[i][j]==0) {  prop0++; mean0+=Img[i][j]; }
       if (MatSeg[i][j])    {  prop1++; mean1+=Img[i][j]; } }
 mean0/=prop0;
 mean1/=prop1;

 var0=var1=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {  if (MatSeg[i][j]==0) var0+=CARRE(Img[i][j]-mean0);
       if (MatSeg[i][j])    var1+=CARRE(Img[i][j]-mean1);  }
 var0/=prop0;
 var1/=prop1;

 VctPar[0][0]=prop0/(lgth*wdth);
 VctPar[1][0]=prop1/(lgth*wdth);
 VctPar[0][1]=mean0;
 VctPar[1][1]=mean1;
 VctPar[0][2]=var0;
 VctPar[1][2]=var1;

 if (mean0>mean1) { SWAP(VctPar[0][0],VctPar[1][0]);
                    SWAP(VctPar[0][1],VctPar[1][1]);
		    SWAP(VctPar[0][2],VctPar[1][2]); }
 
 printf("\n [%.2f::%.0f::%.0f]",VctPar[0][0],VctPar[0][1],VctPar[0][2]);
 printf("\n [%.2f::%.0f::%.0f]",VctPar[1][0],VctPar[1][1],VctPar[1][2]);
 fflush(stdout);

 //>FreeMemory
 if (VctFeat)  free_fmatrix_2d(VctFeat);
 if (VctLabel) free_imatrix_1d(VctLabel);
 if (MatSeg)   free_imatrix_2d(MatSeg);
}

//----------------------------------------------------------
//  GiveRangeGreyLevelValues  (Linear complexity)       
//----------------------------------------------------------     
int GiveRangeGreyLevelValues(float** Img,int lgth,int wdth,float prop)
{
 int i,j,k;
 float min,max;
 float NbPixEachSide;
 int nb;

  //>FindRange
  const int NBGREYLEVEL=256;
  int* vect=imatrix_allocate_1d(NBGREYLEVEL);
  for(k=0;k<NBGREYLEVEL;k++) vect[k]=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) vect[(int)Img[i][j]]++;

  NbPixEachSide=(int)(((1.0-prop)/2)*lgth*wdth);
  printf("[NbPixEachSide=%.0f]",NbPixEachSide);
  fflush(stdout);

  nb=0;
  for(k=0;k<NBGREYLEVEL;k++)
     { nb+=vect[k];
       if (nb>NbPixEachSide) break; }
  min=(k-1);

  nb=0;
  for(k=(NBGREYLEVEL-1);k>=0;k--)
     { nb+=vect[k];
       if (nb>NbPixEachSide) break; }
  max=(k-1);

  printf("\n >  Stat:[min%.0f:max%.0f]>",min,max);
  fflush(stdout);

  //>FreeMemory
  free_imatrix_1d(vect);

  //>Return
  return (max-min);   
}





//----------------------//
//----------------------//
//-- MODEL <CONV> ------//
//----------------------//
//----------------------------------------------------------
// Conv
//----------------------------------------------------------
void Conv(float** ImgIn,float** ImgRes,int lgth,int wdth,float** ConvFilt,int SzwFlt)
{
 int i,j,m,n;
 int posr,posc;
 float tmp;
 int HalfSzFlt=SzwFlt/2;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    {
     tmp=0.0; 
     for(m=-HalfSzFlt;m<=HalfSzFlt;m++) for(n=-HalfSzFlt;n<=HalfSzFlt;n++)
	{
	 posr=i+m;
	 posc=j+n; 	
         if (posr<0)         posr+=lgth;
         if (posr>(lgth-1))  posr-=lgth; 
         if (posc<0)         posc+=wdth;
         if (posc>(wdth-1))  posc-=wdth;
	 tmp+=ImgIn[posr][posc]*ConvFilt[HalfSzFlt-m][HalfSzFlt-n];
	 }
      ImgRes[i][j]=tmp;
    }
}

//----------------------------------------------------------
// Conv [toroidal]
//----------------------------------------------------------
void Conv_(float** ImgIn,float** ImgRes,float** ImgSeg,int lgth,int wdth,float** ConvFilt,int SzwFlt)
{
 int i,j,m,n;
 int posr,posc;
 float tmp;
 int HalfSzFlt=SzwFlt/2;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgRes[i][j]=ImgIn[i][j];

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (ImgSeg[i][j])
    {
     tmp=0.0; 
     for(m=-HalfSzFlt;m<=HalfSzFlt;m++) for(n=-HalfSzFlt;n<=HalfSzFlt;n++)
	{
	 posr=i+m;
	 posc=j+n; 	
         if (posr<0)         posr+=lgth;
         if (posr>(lgth-1))  posr-=lgth; 
         if (posc<0)         posc+=wdth;
         if (posc>(wdth-1))  posc-=wdth;
	 tmp+=ImgIn[posr][posc]*ConvFilt[HalfSzFlt-m][HalfSzFlt-n];
	 }
      ImgRes[i][j]=tmp;
    }
}

//----------------------------------------------------------
// Conv [WithoutEdge]
//----------------------------------------------------------
void Conv(float** ImgIn,float** ImgRes,float** ImgSeg,int lgth,int wdth,float** ConvFilt,int SzwFlt)
{
 int i,j,m,n;
 int posr,posc;
 float tmp;
 int HalfSzFlt=SzwFlt/2;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgRes[i][j]=ImgIn[i][j];

 for(i=HalfSzFlt;i<(lgth-HalfSzFlt);i++) for(j=HalfSzFlt;j<(wdth-HalfSzFlt);j++) if (ImgSeg[i][j])
    {
     tmp=0.0; 
     for(m=-HalfSzFlt;m<=HalfSzFlt;m++) for(n=-HalfSzFlt;n<=HalfSzFlt;n++)
	{
	 posr=i+m;
	 posc=j+n; 	
	 tmp+=ImgIn[posr][posc]*ConvFilt[HalfSzFlt-m][HalfSzFlt-n];
	 }
      ImgRes[i][j]=tmp;
    }
}

//----------------------------------------------------------
// GradConv avec [Line Minimization]&[ImgSeg]
//----------------------------------------------------------
void GradConv(float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth,float** ConvFilt,int SzwFlt)
{
 int i,j,k,m,n,p;
 int posr,posc;
 float Jcost,Jcostp;
 float tmp,tmp1;
 //double tmpD;
 float ITERGRAD;
 float betakp;
 int HalfSzFlt=SzwFlt/2;

 //>GradParameters
 ITERGRAD=200;

 //>Presentation
 printf("\n GradConv [SzwFlt:%d]\n",SzwFlt);
 fflush(stdout);

 //>AllocateMemory
 float** ImgSegAll=fmatrix_allocate_2d(lgth,wdth);
 float** ImgBefFilt=fmatrix_allocate_2d(lgth,wdth);
 float* DJuk=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* DJukp=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* Bkp=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* Dk=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* Dkp=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* TmpV1=fmatrix_allocate_1d(SzwFlt*SzwFlt);
 float* TmpV2=fmatrix_allocate_1d(SzwFlt*SzwFlt);

 //>Initialization
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++) ConvFilt[i][j]=0.0;
 for(k=0;k<(SzwFlt*SzwFlt);k++) DJuk[k]=0.0;
 for(k=0;k<(SzwFlt*SzwFlt);k++) DJukp[k]=0.0;
 for(k=0;k<(SzwFlt*SzwFlt);k++) Bkp[k]=0.0;
 for(k=0;k<(SzwFlt*SzwFlt);k++) Dk[k]=0.0;
 for(k=0;k<(SzwFlt*SzwFlt);k++) Dkp[k]=0.0;
 ConvFilt[(int)(SzwFlt/2)][(int)(SzwFlt/2)]=1.0;
 //for(m=-1;m<=1;m++) for(n=-1;n<=1;n++)  ConvFilt[(int)(SzwFlt/2)+m][(int)(SzwFlt/2)+n]=1.0/9.0;
 //for(m=-2;m<=2;m++) for(n=-2;n<=2;n++)  ConvFilt[(int)(SzwFlt/2)+m][(int)(SzwFlt/2)+n]=1.0/25.0;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgSegAll[i][j]=ImgSeg[i][j];

 if (0)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { for(m=-HalfSzFlt;m<=HalfSzFlt;m++) for(n=-HalfSzFlt;n<=HalfSzFlt;n++)
	{ posr=i+m;
	  posc=j+n; 
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;
	 
	  if (ImgSeg[posr][posc]==0) ImgSegAll[i][j]=0;
        } }

 //>DEBUG
 //Recal(ImgSeg,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"ResImgSeg",ImgSeg,lgth,wdth); 
 //Recal(ImgSegAll,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"ResImgSegAll",ImgSegAll,lgth,wdth);
	   

 //>GRADIENT_ALGORITHM--------------------
 for(k=0;k<ITERGRAD;k++)
    {
      //>----1:[Convolution]>ImgBefFilt----
      Conv(ImgBef,ImgBefFilt,ImgSegAll,lgth,wdth,ConvFilt,SzwFlt); //-<ImgSegAll>
      
     //>----2:[Cost Function]>Jcost----
     Jcost=CostFunction(ImgBefFilt,ImgAft,ImgSegAll,lgth,wdth,ConvFilt,SzwFlt);     
     printf(" [%d:%.1f]",k,Jcost);
     fflush(stdout);   

     //----3:[Grad]--------------------
     //>[A]
     for(m=0;m<SzwFlt;m++) for(n=0;n<SzwFlt;n++)
     DJuk[(m*SzwFlt)+n]=DerCostFunction(ImgBef,ImgBefFilt,ImgAft,ImgSegAll,lgth,wdth,ConvFilt,SzwFlt,m,n);	  
	
    
     //>[B]
     if (k)
        { for(p=0;p<(SzwFlt*SzwFlt);p++) TmpV1[p]=(DJuk[p]-DJukp[p]); 
          for(tmp=0.0,p=0;p<(SzwFlt*SzwFlt);p++)  tmp+=(TmpV1[p]*DJuk[p]);
     	  for(tmp1=0.0,p=0;p<(SzwFlt*SzwFlt);p++) tmp1+=CARRE(DJukp[p]);
     	  betakp=tmp/tmp1; }

      if (!k) for(p=0;p<(SzwFlt*SzwFlt);p++) Dk[p]=(-1.0*DJuk[p]);
      else    for(p=0;p<(SzwFlt*SzwFlt);p++) Dk[p]=(-1.0*DJuk[p])+betakp*Dkp[p];

     //>[C][------MyLineMinimizFunction---------]
      MyLineMinimizFunction(ConvFilt,Dk,SzwFlt,ImgBef,ImgAft,ImgSegAll,lgth,wdth);     
      
      if ((k>5)&&(Jcostp==Jcost))
	 {
           //{ printf("-PolarSymmetryConstraint"); SymPolarPSF(ConvFilt,SzwFlt); } //-Modif--!!!!!
	   break;
          }
	
     //>[D][------Constraint---------]
     //if ((!(k%10))&&(k>1)) { printf("S"); SymPolarPSF(ConvFilt,SzwFlt); } //----Modif--!!!!!
     
     //----4:[Iter]--------------------
     Jcostp=Jcost;
     for(p=0;p<(SzwFlt*SzwFlt);p++) DJukp[p]=DJuk[p];
     for(p=0;p<(SzwFlt*SzwFlt);p++) Dkp[p]=Dk[p];
  
    }//-End-GRADIENT_ALGORITHM------------

 //--Visu-ConvFilt
 //printf("\n");
 //  for(m=0;m<SzwFlt;m++)
 //     { printf("\n");
 //       for(n=0;n<SzwFlt;n++) printf("[%.2f]",ConvFilt[m][n]); }
 //printf("\n");
 
 //>Sauvegarde
 //Conv(ImgBef,ImgBefFilt,ImgSeg,lgth,wdth,ConvFilt,SzwFlt);
 //Jcost=0.0;
 //for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (ImgSeg[i][j]) Jcost+=CARRE(ImgBefFilt[i][j]-ImgAft[i][j]);
 //Jcost/=(lgth*wdth);
 //printf(" [%.2f]",Jcost);
 //if (0) printf(" [%.2f]",Jcostp);
 //fflush(stdout);
 
 //SaveImagePgm((char*)"",(char*)"ResImgBef",ImgBef,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"ResImgBefFilt",ImgBefFilt,lgth,wdth);

 //>DEBUG
 //Recal(ImgSeg,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"ResImgSeg",ImgSeg,lgth,wdth); 
 //Recal(ImgSegAll,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"ResImgSegAll",ImgSegAll,lgth,wdth);
 //exit(-1);

 //>FreeMemory
 if (ImgSegAll)  free_fmatrix_2d(ImgSegAll);
 if (ImgBefFilt) free_fmatrix_2d(ImgBefFilt);
 if (DJuk)  free_fmatrix_1d(DJuk);
 if (DJukp) free_fmatrix_1d(DJukp);
 if (Bkp) free_fmatrix_1d(Bkp);
 if (Dk)  free_fmatrix_1d(Dk);
 if (Dkp) free_fmatrix_1d(Dkp);
 if (TmpV1) free_fmatrix_1d(TmpV1);
 if (TmpV2) free_fmatrix_1d(TmpV2);
}


//----------------------
/*----------------------------------------------------*/
/* BilinearInterpolation                              */
/*----------------------------------------------------*/
float BilinearInterp(float** img,int lgth,int wdth,float row,float col)  
{
 int col_inf,col_sup;
 int row_inf,row_sup;
 float t,u;
 float ng;

 col_inf=(int)(col);
 col_sup=(int)(col+1);
 row_inf=(int)(row);
 row_sup=(int)(row+1);
 t=(col-col_inf)/(col_sup-col_inf);
 u=(row-row_inf)/(row_sup-row_inf);

 ng=0.0;
 if ((col_inf>=0)&&(row_inf>=0)&&(col_sup<wdth)&&(row_sup<lgth))
    { ng=(1-t)*(1-u)*img[row_inf][col_inf];
      ng+=t*(1-u)*img[row_inf][col_sup];
      ng+=t*u*img[row_sup][col_sup];
      ng+=(1-t)*u*img[row_sup][col_inf]; }

 //DEBUG
 //if (isnan(ng)) printf("\n [%.2f:::%d:%d][%.2f:::%d:%d]::[%.3f]",row,row_inf,row_sup,col,col_inf,col_sup,ng);

 return ng;  
}

//---------------------------------------------------------
// SymPolarPSF
//---------------------------------------------------------
void SymPolarPSF(float** ConvFilt,int SzwFlt)
{
 int i,j,k,l;
 int dist;
 int RowMidPts,ColMidPts;
 const int HALFSZWFLT=(int)(SzwFlt/2); 
  
 //>AllocateMemory_Init
 float** ConvFiltPol=fmatrix_allocate_2d(SzwFlt,SzwFlt);
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++) ConvFiltPol[i][j]=0.0;
 ConvFiltPol[HALFSZWFLT][HALFSZWFLT]=ConvFilt[HALFSZWFLT][HALFSZWFLT];

 float** Tab=fmatrix_allocate_2d(SzwFlt*SzwFlt,2);
 for(k=0;k<(SzwFlt*SzwFlt);k++) for(l=0;l<2;l++) Tab[k][l]=0.0;

 //>FillTab
 RowMidPts=HALFSZWFLT;
 ColMidPts=HALFSZWFLT;
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++)
    { dist=CARRE(i-RowMidPts)+CARRE(j-ColMidPts);
      Tab[dist][0]+=ConvFilt[i][j];
      Tab[dist][1]++; }

 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++)
    { dist=CARRE(i-RowMidPts)+CARRE(j-ColMidPts);
      ConvFiltPol[i][j]=(Tab[dist][0]/Tab[dist][1]); }

 //>Transfert
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++) ConvFilt[i][j]=ConvFiltPol[i][j];

 //>FreeMemory
 if (ConvFiltPol) free_fmatrix_2d(ConvFiltPol);
 if (Tab) free_fmatrix_2d(Tab);
}


//---------------------------------------------------------
// SymPolarPSF
//---------------------------------------------------------
void SymPolarPSF(float* ConvFltDec,int SzWFlt)
{
 int i,j,k;
  
 //>AllocateMemory
 float** ConvFlt=fmatrix_allocate_2d(SzWFlt,SzWFlt);

 //>float* ConvFltDec --> float** ConvFlt
 k=1;
 for(i=0;i<SzWFlt;i++) for(j=0;j<SzWFlt;j++) { ConvFlt[i][j]=ConvFltDec[k]; k++; }

 //>Symetrize
 SymPolarPSF(ConvFlt,SzWFlt);

 //>float** ConvFlt --> float* ConvFltDec
 k=1;
 for(i=0;i<SzWFlt;i++) for(j=0;j<SzWFlt;j++) { ConvFltDec[k]=ConvFlt[i][j]; k++; }
 
 //>FreeMemory
 if (ConvFlt) free_fmatrix_2d(ConvFlt);
}

//----------------------
//---------------------------------------------------------
// COST_FUNCTION
//---------------------------------------------------------
float CostFunction(float** ImgBefFilt,float** ImgAft,float** ImgSegAll,int lgth,int wdth,float** ConvFilt,int SzwFlt)
{
 int i,j;
 float Jcost=0.0;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (ImgSegAll[i][j]) Jcost+=CARRE(ImgBefFilt[i][j]-ImgAft[i][j]); 
 Jcost/=(lgth*wdth);

 return Jcost;
}

//---------------------------------------------------------
// DERIVATE_COST_FUNCTION
//----------------------------------------------------------
float DerCostFunction(float** ImgBef,float** ImgBefFilt,float** ImgAft,float** ImgSegAll,\
		      int lgth,int wdth,float** ConvFilt,int SzwFlt,int m,int n)
{
 int i,j;
 int HalfSzFlt=SzwFlt/2;
 double tmpD=0.0;

 if (!((m==HalfSzFlt)&&(n==HalfSzFlt)))
 for(i=SzwFlt;i<(lgth-SzwFlt);i++) for(j=SzwFlt;j<(wdth-SzwFlt);j++)
 if (ImgSegAll[i][j]) tmpD+=2*(ImgBefFilt[i][j]-ImgAft[i][j])*(ImgBef[i+HalfSzFlt-m][j+HalfSzFlt-n]);  

return tmpD;
}	 


 
