//------------------------------------------------------
// module  : FunctionMCDRIF2.cc
// auteur  : Mignotte Max et Redha Touati
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionMCDRIF.h"
#include "FunctionMCDRIF2.h"
#include "MCDRIF.h"

//------------------------------------------------
// GLOBAL VARIABLES
//------------------------------------------------
float *pcom,*xicom;

//------------------------------------------------
// FUNCTIONS
//------------------------------------------------
//-------------------------//
//-------- Recipes --------//
//-- Line Minimization ----//
//                         //
// dlinmin                 //
// dbrent                  //
// mnbrak                  //
// f1dim                   //
// df1dim                  //
//-------------------------//
//---------------------------------------------------------
//  MyLineMinimizFunction
//---------------------------------------------------------
void MyLineMinimizFunction(float** ConvFlt,float* Dk,int SzwFlt,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
 int i,j,k;
 int nDim=(SzwFlt*SzwFlt);

 //>AllocateMemory_&_Initialization[Shifting]
 float* ConvFltDec=fmatrix_allocate_1d(nDim+1); //::nDim-dimensional Point
 float* DkDec=fmatrix_allocate_1d(nDim+1);      //::nDim-dimensional Direction

 k=1;
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++) { ConvFltDec[k]=ConvFlt[i][j]; k++; }
 for(k=0;k<(SzwFlt*SzwFlt);k++) DkDec[k+1]=Dk[k];
 
 //>Call_[-Line Minimization-]
 dlinmin(ConvFltDec,DkDec,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);

 //>Recup OptimalPts__[p-->ConvFlt]
 k=1;
 for(i=0;i<SzwFlt;i++) for(j=0;j<SzwFlt;j++) { ConvFlt[i][j]=ConvFltDec[k]; k++; }
 
 //>FreeMemory
 if (ConvFltDec) free_fmatrix_1d(ConvFltDec);
 if (DkDec) free_fmatrix_1d(DkDec);     
}

//---------------------------------------------------------
// dlinmin
//---------------------------------------------------------
void dlinmin(float* p,float* xi,int n,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
	int j;
	float xx,xmin,fx,fb,fa,bx,ax;
	float ValCostFunction;

	//int ncom=n;
	int nDim=n;
	pcom=fmatrix_allocate_1d(n+1);    //GlobalVariable
	xicom=fmatrix_allocate_1d(n+1);   //GlobalVariable
	
	for (j=1;j<=n;j++) {
		pcom[j]=p[j];
		xicom[j]=xi[j];
	}
	ax=0.0;
	xx=1.0;
	mnbrak(&ax,&xx,&bx,&fa,&fx,&fb,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);
	ValCostFunction=dbrent(ax,xx,bx,TOL,&xmin,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);
	for (j=1;j<=n;j++) {
		xi[j] *= xmin;
		p[j] += xi[j];
	}
	if (pcom)  free_fmatrix_1d(pcom); 
	if (xicom) free_fmatrix_1d(xicom);

	if (0) printf("[%.2f]",ValCostFunction);
	//printf("(%.2f)",ValCostFunction);
}

//---------------------------------------------------------
// mnbrak 
//---------------------------------------------------------
void mnbrak(float* ax,float* bx,float* cx,float* fa,float* fb,float* fc,\
	    int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
	float ulim,u,r,q,fu,dum;

	*fa=f1dim(*ax,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);  //*fa=(*func)(*ax);  
	*fb=f1dim(*bx,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);  //*fb=(*func)(*bx);
	if (*fb > *fa) {
		SHFT(dum,*ax,*bx,dum)
		SHFT(dum,*fb,*fa,dum)
	}
	*cx=(*bx)+GOLD*(*bx-*ax);
	*fc=f1dim(*cx,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //*fc=(*func)(*cx);
	while (*fb > *fc) {
		r=(*bx-*ax)*(*fb-*fc);
		q=(*bx-*cx)*(*fb-*fa);
		u=(*bx)-((*bx-*cx)*q-(*bx-*ax)*r)/
			(2.0*SIGN(FMAX(fabs(q-r),TINY),q-r));
		ulim=(*bx)+GLIMIT*(*cx-*bx);
		if ((*bx-u)*(u-*cx) > 0.0) {
		  fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*func)(u);
			if (fu < *fc) {
				*ax=(*bx);
				*bx=u;
				*fa=(*fb);
				*fb=fu;
				return;
			} else if (fu > *fb) {
				*cx=u;
				*fc=fu;
				return;
			}
			u=(*cx)+GOLD*(*cx-*bx);
			fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*func)(u);
		} else if ((*cx-u)*(u-ulim) > 0.0) {
		        fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*func)(u);
			if (fu < *fc) {
				SHFT(*bx,*cx,u,*cx+GOLD*(*cx-*bx))
				SHFT(*fb,*fc,fu,f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth))    //SHFT(*fb,*fc,fu,(*func)(u))
			}
		} else if ((u-ulim)*(ulim-*cx) >= 0.0) {
			u=ulim;
			fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*func)(u);
		} else {
			u=(*cx)+GOLD*(*cx-*bx);
			fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*func)(u);
		}
		SHFT(*ax,*bx,*cx,u)
		SHFT(*fa,*fb,*fc,fu)
	}
}

//---------------------------------------------------------
// dbrent 
//---------------------------------------------------------
float dbrent(float ax,float bx,float cx,float tol,float* xmin,\
	     int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
	int iter,ok1,ok2;
	float a,b,d,d1,d2,du,dv,dw,dx,e=0.0;
	float fu,fv,fw,fx,olde,tol1,tol2,u,u1,u2,v,w,x,xm;

	a=(ax < cx ? ax : cx);
	b=(ax > cx ? ax : cx);
	x=w=v=bx;
	fw=fv=fx=f1dim(x,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);   //fw=fv=fx=(*f)(x);  
	dw=dv=dx=df1dim(x,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);  //dw=dv=dx=(*df)(x); 
	for (iter=1;iter<=ITMAX;iter++) {
		xm=0.5*(a+b);
		tol1=tol*fabs(x)+ZEPS;
		tol2=2.0*tol1;
		if (fabs(x-xm) <= (tol2-0.5*(b-a))) {
			*xmin=x;
			return fx;
		}
		if (fabs(e) > tol1) {
			d1=2.0*(b-a);
			d2=d1;
			if (dw != dx) d1=(w-x)*dx/(dx-dw);
			if (dv != dx) d2=(v-x)*dx/(dx-dv);
			u1=x+d1;
			u2=x+d2;
			ok1 = (a-u1)*(u1-b) > 0.0 && dx*d1 <= 0.0;
			ok2 = (a-u2)*(u2-b) > 0.0 && dx*d2 <= 0.0;
			olde=e;
			e=d;
			if (ok1 || ok2) {
				if (ok1 && ok2)
					d=(fabs(d1) < fabs(d2) ? d1 : d2);
				else if (ok1)
					d=d1;
				else
					d=d2;
				if (fabs(d) <= fabs(0.5*olde)) {
					u=x+d;
					if (u-a < tol2 || b-u < tol2)
						d=SIGN(tol1,xm-x);
				} else {
					d=0.5*(e=(dx >= 0.0 ? a-x : b-x));
				}
			} else {
				d=0.5*(e=(dx >= 0.0 ? a-x : b-x));
			}
		} else {
			d=0.5*(e=(dx >= 0.0 ? a-x : b-x));
		}
		if (fabs(d) >= tol1) {
			u=x+d;
			fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*f)(u);
		} else {
			u=x+SIGN(tol1,d);
			fu=f1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //fu=(*f)(u);
			if (fu > fx) {
				*xmin=x;
				return fx;
			}
		}
		du=df1dim(u,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth); //du=(*df)(u);
		if (fu <= fx) {
			if (u >= x) a=x; else b=x;
			MOV3(v,fv,dv, w,fw,dw)
			MOV3(w,fw,dw, x,fx,dx)
			MOV3(x,fx,dx, u,fu,du)
		} else {
			if (u < x) a=u; else b=u;
			if (fu <= fw || w == x) {
				MOV3(v,fv,dv, w,fw,dw)
				MOV3(w,fw,dw, u,fu,du)
			} else if (fu < fv || v == x || v == w) {
				MOV3(v,fv,dv, u,fu,du)
			}
		}
	}
	printf("Too many iterations in routine dbrent");
	return 0.0;
}

//---------------------------------------------------------
// f1dim::
// >>> MyFunction_1dim
//---------------------------------------------------------
float f1dim(float x,int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
	int j;
	float f,*xt;
	int ncom=nDim;

	xt=fmatrix_allocate_1d(ncom+1); 
	for (j=1;j<=ncom;j++) xt[j]=pcom[j]+x*xicom[j];
	
	//f=(*nrfunc)(xt); //-Ok
        //Function_To_Be_Optimized_[ImgSeg]
	f=MyFuncToBeOptimized(xt,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);
	
	if (xt) free_fmatrix_1d(xt); 
	return f;
}

//---------------------------------------------------------
// df1dim
// >>>> MyDerivateFunction_1dim
//---------------------------------------------------------
float df1dim(float x,int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
	int j;
	float df1=0.0;
	float *xt,*df;
	int ncom=nDim;

	xt=fmatrix_allocate_1d(ncom+1); 
	df=fmatrix_allocate_1d(ncom+1); 
	for (j=1;j<=ncom;j++) xt[j]=pcom[j]+x*xicom[j];
	
	//(*nrdfun)(xt,df); //-Ok
	//Function Derivate_[ImgSeg]
	MyDerivateFunc(xt,df,nDim,ImgBef,ImgAft,ImgSeg,lgth,wdth);
		
	for (j=1;j<=ncom;j++) df1 += df[j]*xicom[j];
	if (df) free_fmatrix_1d(df); 
	if (xt) free_fmatrix_1d(xt); 
	return df1;
}

//---------------------------------------------------------
// +++++++++ MyFuncToBeOptimized ++++++++++++++
//---------------------------------------------------------
float MyFuncToBeOptimized(float* xt,int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
 int i,j,k;
 float Jcost;
 int SzWFlt=(int)(sqrt(nDim));

  //>AllocateMemory_&_Initialization[Shifting]
  float** ImgBefFilt=fmatrix_allocate_2d(lgth,wdth);
  float** LocConvFlt=fmatrix_allocate_2d(SzWFlt,SzWFlt); //::LocConvFlt::nDim-dimensional Point

  //>Convolution_[ImgSeg]
  k=1;
  for(i=0;i<SzWFlt;i++) for(j=0;j<SzWFlt;j++) { LocConvFlt[i][j]=xt[k]; k++; }
  Conv(ImgBef,ImgBefFilt,ImgSeg,lgth,wdth,LocConvFlt,SzWFlt);

  //>MyCostFunction_[ImgSeg]
  //Jcost=0.0;
  //for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (ImgSeg[i][j]) Jcost+=CARRE(ImgBefFilt[i][j]-ImgAft[i][j]);
  //Jcost/=(lgth*wdth);
  Jcost=CostFunction(ImgBefFilt,ImgAft,ImgSeg,lgth,wdth,LocConvFlt,SzWFlt);
  
 //>FreeMemory
 if (LocConvFlt) free_fmatrix_2d(LocConvFlt);
 if (ImgBefFilt) free_fmatrix_2d(ImgBefFilt);   

 //>Return
 return Jcost;
}

//---------------------------------------------------------
// +++++++++ MyFuncToBeOptimized  +++++++++ 
//---------------------------------------------------------
void MyDerivateFunc(float* xt,float* df,int nDim,float** ImgBef,float** ImgAft,float** ImgSeg,int lgth,int wdth)
{
 int i,j,k,m,n;
 //double tmpD;
 int SzWFlt=(int)(sqrt(nDim));
 //int HalfSzFlt=(int)(SzWFlt/2);
 
 //>AllocateMemory_&_Initialization[Shifting]
 float* DJuk=fmatrix_allocate_1d(SzWFlt*SzWFlt);
 float** ImgBefFilt=fmatrix_allocate_2d(lgth,wdth);
 float** LocConvFlt=fmatrix_allocate_2d(SzWFlt,SzWFlt); //::LocConvFlt::nDim-dimensional_Point

 //>Convolution_[ImgSeg]
 k=1;
 for(i=0;i<SzWFlt;i++) for(j=0;j<SzWFlt;j++) { LocConvFlt[i][j]=xt[k]; k++; }
 Conv(ImgBef,ImgBefFilt,ImgSeg,lgth,wdth,LocConvFlt,SzWFlt);

 //>Calcul_Gradient_[ImgSeg]
 for(m=0;m<SzWFlt;m++) for(n=0;n<SzWFlt;n++)
	{
	  //tmpD=0.0; 
          //for(i=SzWFlt;i<(lgth-SzWFlt);i++) for(j=SzWFlt;j<(wdth-SzWFlt);j++)
	  //if (ImgSeg[i][j]) tmpD+=2*(ImgBefFilt[i][j]-ImgAft[i][j])*(ImgBef[i+HalfSzFlt-m][j+HalfSzFlt-n]);  

	  //DJuk[(m*SzWFlt)+n]=tmpD;
          DJuk[(m*SzWFlt)+n]=DerCostFunction(ImgBef,ImgBefFilt,ImgAft,ImgSeg,lgth,wdth,LocConvFlt,SzWFlt,m,n);
	}

 //>Contraints-?-
 //SymPolarPSF(LocConvFlt,SzWFlt);   //----Modif

 //>Intodf
 df[0]=0.0;
 for(k=1;k<=(SzWFlt*SzWFlt);k++) df[k]=DJuk[k-1];

 //>FreeMemory
 if (DJuk)  free_fmatrix_1d(DJuk);
 if (LocConvFlt) free_fmatrix_2d(LocConvFlt);
 if (ImgBefFilt) free_fmatrix_2d(ImgBefFilt);  
}



