//---------------------------------------------------
// module  : f_MCDRIF.cc                       
// auteur  : Max Mignotte et Redha Touati                         
// date    :                                              
// langage : C++                                      
// labo    : DIRO                                 
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "MCDRIF.h"

//------------------------------------------------
// METHODES DE LA CLASSE MCDRIF ------------------
//------------------------------------------------
//----------------------------------------------------------
// MCDRIF constructor <Markov-CCL>
//----------------------------------------------------------
MCDRIF::MCDRIF(float*** imgbef,float*** imgaft,float*** imggtr,int lgth,int wdth,char* NmImg,float MyPar)           
 {
  int i,j,k;

  //>Initialization
  length=lgth;
  width=wdth;
  strcpy(NameImg,NmImg);

  MyParam=MyPar;
  FlgSave=0;
  
  //>Memory_Allocation 
  MatImgBef=fmatrix_allocate_3d(TROIS,length,width);
  MatImgAft=fmatrix_allocate_3d(TROIS,length,width);
  MatImgGtr=fmatrix_allocate_3d(TROIS,length,width);
  MatImgSeg=fmatrix_allocate_3d(TROIS,length,width);
  MatImgCon=fmatrix_allocate_3d(TROIS,length,width);
  MatImgBefWB=fmatrix_allocate_2d(length,width);
  MatImgAftWB=fmatrix_allocate_2d(length,width);
  MatImgGtrWB=fmatrix_allocate_2d(length,width);
  MatImgSegWB=fmatrix_allocate_2d(length,width);
  MatImgIniWB=fmatrix_allocate_2d(length,width);
  MatColFeat=fmatrix_allocate_2d(length*width,TROIS);

  MatImgTmp1=fmatrix_allocate_2d(length,width);
  MatImgTmp2=fmatrix_allocate_2d(length,width);
  MatImgTmp3=fmatrix_allocate_2d(length,width);
  MatImgTmp4=fmatrix_allocate_2d(length,width);

  //>Init_&_LoadMatrix
  for(k=0;k<TROIS;k++) for(i=0;i<length;i++) for(j=0;j<width;j++) 
     { MatImgBef[k][i][j]=imgbef[k][i][j];     
       MatImgAft[k][i][j]=imgaft[k][i][j];
       MatImgGtr[k][i][j]=imggtr[k][i][j];
       MatImgSeg[k][i][j]=0.0;
       MatImgCon[k][i][j]=0.0; }

  //>Flag_Color_Img
  FlgColorImgB=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgBef[1][i][j]!=MatImgBef[2][i][j]) { FlgColorImgB=1; }
  FlgColorImgA=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgAft[0][i][j]!=MatImgAft[2][i][j]) { FlgColorImgA=1; }
  if (FlgColorImgB) printf(" [Image_Before_In_Color]");
  if (FlgColorImgA) printf(" [Image_After_In_Color]");
  if ((FlgColorImgB==0)&&(FlgColorImgA==0)) printf(" [Image_Before_&_After_In_GreyScale]");
  printf("\n Parameters::[MyPar=%.3f]",MyPar);
  printf("\n");

  //>Color-GreyScale Conversion
  //---------------------------
  //>Average_based-Method 
  if (0)
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=((1.0/3.0)*MatImgBef[0][i][j])+((1.0/3.0)*MatImgBef[1][i][j])+((1.0/3.0)*MatImgBef[2][i][j]);
      MatImgAftWB[i][j]=((1.0/3.0)*MatImgAft[0][i][j])+((1.0/3.0)*MatImgAft[1][i][j])+((1.0/3.0)*MatImgAft[2][i][j]); }

  //>Luminosity_based-Method 
  if (0)
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=0.21*MatImgBef[0][i][j]+0.72*MatImgBef[1][i][j]+0.07*MatImgBef[2][i][j];
      MatImgAftWB[i][j]=0.21*MatImgAft[0][i][j]+0.72*MatImgAft[1][i][j]+0.07*MatImgAft[2][i][j]; }

  //>lightnesss_based-Method 
  if (1) 
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=0.50*MAX(MAX(MatImgBef[0][i][j],MatImgBef[1][i][j]),MatImgBef[2][i][j]);
      MatImgBefWB[i][j]+=0.50*MIN(MIN(MatImgBef[0][i][j],MatImgBef[1][i][j]),MatImgBef[2][i][j]);
      MatImgAftWB[i][j]=0.50*MAX(MAX(MatImgAft[0][i][j],MatImgAft[1][i][j]),MatImgAft[2][i][j]);
      MatImgAftWB[i][j]+=0.50*MIN(MIN(MatImgAft[0][i][j],MatImgAft[1][i][j]),MatImgAft[2][i][j]); }

  //>BandSelection
  if (0)
     { SelectBand(MatImgBef,length,width,MatImgBefWB);
       SelectBand(MatImgAft,length,width,MatImgAftWB); }
     
   //>Init
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgIniWB[i][j]=0;				  
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgGtrWB[i][j]=MatImgGtr[0][i][j];
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgSegWB[i][j]=0;
  
   //>Verif->MatImgGtrWB
   k=0;
   for(i=0;i<length;i++) for(j=0;j<width;j++) if (!((MatImgGtrWB[i][j]==0)||(MatImgGtrWB[i][j]==255))) k++;
   if (k) { printf(" > Probleme: VeriteTerrain avec %d NonWhite || NonBlack pixels\n",k);
            fflush(stdout); }
 
 //Stack_Size_Increased_[128 MB]
 const rlim_t kStackSize=128*1024*1024;   
 struct rlimit rl;
 int result=getrlimit(RLIMIT_STACK,&rl);
 if (result==0)
 if (rl.rlim_cur<kStackSize)
    {  rl.rlim_cur=kStackSize;
       result=setrlimit(RLIMIT_STACK,&rl);
       if (result!=0) fprintf(stderr,"setrlimit returned result = %d\n",result); } 
 }

//----------------------------------------------------------
// MCDRIF destructor
//----------------------------------------------------------
MCDRIF::~MCDRIF()
{ 
  //Memory_Liberation
  if (MatImgBef)  free_fmatrix_3d(MatImgBef,3);
  if (MatImgAft)  free_fmatrix_3d(MatImgAft,3);
  if (MatImgGtr)  free_fmatrix_3d(MatImgGtr,3);
  if (MatImgSeg)  free_fmatrix_3d(MatImgSeg,3);
  if (MatImgCon)  free_fmatrix_3d(MatImgCon,3);
  if (MatImgBefWB)  free_fmatrix_2d(MatImgBefWB);
  if (MatImgAftWB)  free_fmatrix_2d(MatImgAftWB);
  if (MatImgGtrWB)  free_fmatrix_2d(MatImgGtrWB);
  if (MatImgSegWB)  free_fmatrix_2d(MatImgSegWB);
  if (MatImgIniWB)  free_fmatrix_2d(MatImgIniWB);
  if (MatImgTmp1)   free_fmatrix_2d(MatImgTmp1);
  if (MatImgTmp2)   free_fmatrix_2d(MatImgTmp2);
  if (MatImgTmp3)   free_fmatrix_2d(MatImgTmp3);
  if (MatImgTmp4)   free_fmatrix_2d(MatImgTmp4);
  if (MatColFeat)   free_fmatrix_2d(MatColFeat);
}

//----------------------------------------------------------
//----------------------------------------------------------
// Multimodal Detection : <Ipta19>
// --------------------------------
//
//
// > -TESTS-<ipta19> (13 Imgs)
// > Precision:[94.85][85.78][91.79][89.67][86.09][82.35][95.94][96.35][91.26][85.94][87.30][84.01][81.48]
// > Fmeasure:[0.41][0.38][0.41][0.30][0.24][0.45][0.17][0.73][0.43][0.64][0.04][0.39][0.47]
// > PrecMoy=[88.68]  FmeasMoy=[0.389]
//
//
//----------------------------------------------------------
void MCDRIF::DetectionMCD_CONV_()
{
  int k;
  int nbreg;
  Chrono chrono;

  //>Model-Parameters
  const int NBITERPF=2; 
  const int SzwFlt=9;  
  const int NBITEREM=12; 
  
  const int SIZEMINREG=40;
  const int   DEPTH=9;
  const float THETA=0.9;
  
  const int NBCLASS=2;
  const int GAUSSIAN_LAW=1;
  const float SPATIALBETA=1.0;
  const int VISU_MAT=0;
  
  //>[MemoryAllocation_&_Initialization]
  chrono.reset();
  float** MatImgBefWBEQ=fmatrix_allocate_2d(length,width);
  float** MatImgAftWBEQ=fmatrix_allocate_2d(length,width);
  float** ConvFilt=fmatrix_allocate_2d(SzwFlt,SzwFlt);
  float** ImgSeg=fmatrix_allocate_2d(length,width);
  float** ImgDif1=fmatrix_allocate_2d(length,width);
  float** ImgDif2=fmatrix_allocate_2d(length,width);
  float** ImgDif=fmatrix_allocate_2d(length,width);
  float** ImgBefFilt=fmatrix_allocate_2d(length,width);
  float** ImgAftFilt=fmatrix_allocate_2d(length,width);
  float** ppar=fmatrix_allocate_2d(NBCLASS,TROIS);
  float** ImgHist=fmatrix_allocate_2d(256,256);
  InitZero(ImgDif,length,width);
  InitZero(ImgDif1,length,width);
  InitZero(ImgDif2,length,width);
  InitZero(MatImgTmp1,length,width);
  InitZero(MatImgTmp2,length,width);

  float*  hyperpar=fmatrix_allocate_1d(4);
  for(k=0;k<4;k++) hyperpar[k]=SPATIALBETA;

  //-------------
  //>---[1]------
  //-------------
  printf("\n [1] _PreProcessing_Step_[%s]",NameImg);
  fflush(stdout);
  CopyMat(MatImgBefWBEQ,MatImgBefWB,length,width);
  CopyMat(MatImgAftWBEQ,MatImgAftWB,length,width);
 
  //-------------
  //>---[2]------
  //-------------
  printf("\n\n [2] _Parameter_Estimation_Step_[%s]",NameImg);

  for(k=0;k<NBITERPF;k++)
     {
      printf("\n\n-------");
      printf("\n-[%d]-",k);
      printf("\n-------");
      
      printf("\n Convolutive_Transformation_Estimation");   
      if (k==0) InitOne(ImgSeg,length,width);

      GradConv(MatImgBefWBEQ,MatImgAftWB,ImgSeg,length,width,ConvFilt,SzwFlt);
      VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
      if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
      InfoStatConv(ConvFilt,SzwFlt,SzwFlt);
      Conv(MatImgBefWBEQ,ImgBefFilt,ImgSeg,length,width,ConvFilt,SzwFlt);
      InfoStatMat(ImgBefFilt,length,width);
      DiffAbs(ImgBefFilt,MatImgAftWB,ImgDif1,length,width,SzwFlt);
      Recal(ImgDif1,length,width);
      //::SAVE::
      //SaveImagePgm((char*)"",(char*)"ResImgDif1",ImgDif1,length,width);
      //Recal(ImgBefFilt,length,width);
      //SaveImagePgm((char*)"",(char*)"ResImgBefFilt-",ImgBefFilt,length,width);

      GradConv(MatImgAftWBEQ,MatImgBefWB,ImgSeg,length,width,ConvFilt,SzwFlt);
      VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
      if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
      InfoStatConv(ConvFilt,SzwFlt,SzwFlt);
      Conv(MatImgAftWBEQ,ImgAftFilt,ImgSeg,length,width,ConvFilt,SzwFlt);
      InfoStatMat(ImgAftFilt,length,width);
      DiffAbs(ImgAftFilt,MatImgBefWB,ImgDif2,length,width,SzwFlt);
      Recal(ImgDif2,length,width);
      //::SAVE::
      //SaveImagePgm((char*)"",(char*)"ResImgDif2",ImgDif2,length,width); 

      AddToMatrix(ImgDif,ImgDif1,length,width);
      AddToMatrix(ImgDif,ImgDif2,length,width);
      Recal(ImgDif,length,width);
      //::SAVE::
      //SaveImagePgm((char*)"",(char*)"ResImgDif",ImgDif,length,width); 
    
      printf("\n Expectation_Maximization_Estimation");
      ppar[0][0]=ppar[1][0]=0.5;
      ppar[0][2]=ppar[1][2]=100;
      ppar[0][1]=100;
      ppar[1][1]=200;
      EM MyEm(NBCLASS,GAUSSIAN_LAW,length,width);
      MyEm.EM_Estimate(ImgDif,ppar,NBITEREM);
      MyEm.InitMvMatrix(ImgSeg);
      Recal(ImgSeg,length,width);
      NegateMatrix(ImgSeg,length,width);
      
      //::SAVE::
      //FillPictHist(ImgHist,256,ImgDif1,length,width,ppar);
      //SaveImagePgm((char*)"",(char*)"ResImgHist",ImgHist,256,256);
      //SaveImagePgm((char*)"",(char*)"ResImgSegIt",ImgSeg,length,width); 
     }

  FillPictHist(ImgHist,256,ImgDif,length,width,ppar);
  SaveImagePgm((char*)"",(char*)"ResImgHist",ImgHist,256,256);
 

  //-------------
  //>---[3]------
  //-------------
  printf("\n\n [3] _Segmentation_Step_[%s]",NameImg);
  InitZero(MatImgSegWB,length,width);
  CopyMat(MatImgSegWB,ImgSeg,length,width); 
  //::SAVE::
  //Recal(MatImgSegWB,length,width);  
  //SaveImagePgm((char*)"",(char*)"ResImgSegInit",MatImgSegWB,length,width); 

  SMAP* MySmap=new SMAP(length,width,DEPTH);
  (*MySmap).SMAP_Estimate(ImgDif,ppar,THETA,2,MatImgSegWB);
  if (MySmap) delete (MySmap); 
  
  FuseSmallRegions(MatImgSegWB,length,width,&nbreg,SIZEMINREG);
  Recal(MatImgSegWB,length,width);
  //::SAVE::
  //SaveImagePgm((char*)"",(char*)"ResMarkovSeg",MatImgSegWB,length,width);

 //-------------
 //>---[4]------
 //-------------
 //>[Result_&_Save]
 printf("\n\n [4]  _Result_Step_[%s]",NameImg);
 printf("\n");
 elptime=chrono.elapsed(SECOND);
 chrono.print();
 float* Result=fmatrix_allocate_1d(4);
 CopyMat(MatImgSeg,MatImgSegWB,length,width);
 ConfusionMatrix(MatImgCon,MatImgSegWB,MatImgGtrWB,length,width,Result);
 fmeasure=FMeasure(MatImgSegWB,MatImgGtrWB,length,width);
 precision=Precis(MatImgSegWB,MatImgGtrWB,length,width);
 sprintf(InfoCD,"%s_%s-CF_Fm%.2f_Pr%.1f_Tm%d",NameImg,MyCom,fmeasure,precision,elptime);

 //::SAVE:: 
 //SaveImagePgm(InfoCD,(char*)"ResDif",ImgDif,length,width);
 SaveImagePgm(InfoCD,(char*)"ResSeg",MatImgSegWB,length,width);
 SaveImagePpm(InfoCD,(char*)"ResConfus",MatImgCon,length,width);
    
  //>FreeMemory_&_End
  if (MatImgBefWBEQ) free_fmatrix_2d(MatImgBefWBEQ);
  if (MatImgAftWBEQ) free_fmatrix_2d(MatImgAftWBEQ);
  if (ConvFilt) free_fmatrix_2d(ConvFilt);
  if (ImgSeg) free_fmatrix_2d(ImgSeg);
  if (ImgDif) free_fmatrix_2d(ImgDif);
  if (ImgDif1) free_fmatrix_2d(ImgDif1);
  if (ImgDif2) free_fmatrix_2d(ImgDif2);	 
  if (ImgBefFilt) free_fmatrix_2d(ImgBefFilt);
  if (ImgAftFilt) free_fmatrix_2d(ImgAftFilt);
  if (ppar)       free_fmatrix_2d(ppar);
  if (hyperpar)   free_fmatrix_1d(hyperpar);
  if (ImgHist)    free_fmatrix_2d(ImgHist);
  printf("\n\n [END]\n");
}

//----------------------------------------------------------
//----------------------------------------------------------
// Multimodal Detection : <JOURNAL19>
// ---------------------------------------
//
// > [B_&_W]
// > Img1-B.ppm_-CF_Fm0.49_Pr92.3_Tm26ResSeg.pgm
// > Img3-A.ppm_-CF_Fm0.37_Pr82.8_Tm41ResSeg.pgm
// > Img5-Bc.ppm_-CF_Fm0.41_Pr89.6_Tm23ResSeg.pgm
// > Img6-B.ppm_-CF_Fm0.31_Pr88.2_Tm35ResSeg.pgm
// > Img9-B.ppm_-CF_Fm0.47_Pr81.1_Tm42ResSeg.pgm
// > Img11-B.ppm_-CF_Fm0.23_Pr93.4_Tm35ResSeg.pgm
// > Img12-B.ppm_-CF_Fm0.68_Pr95.5_Tm37ResSeg.pgm
// > Img13-B.ppm_-CF_Fm0.35_Pr86.6_Tm38ResSeg.pgm
// > Img17-Bc.ppm_-CF_Fm0.56_Pr86.5_Tm48ResSeg.pgm
//
// > [Couleur-Couleur]
// > Img7-Bc.ppm_-CF_Fm0.32_Pr85.7_Tm178ResSeg.pgm
// > Img14-Ac.ppm_-CF_Fm0.64_Pr85.8_Tm50ResSeg.pgm
// > Img18-Bc.ppm_-CF_Fm0.40_Pr83.2_Tm46ResSeg.pgm
// > Img19-Bc.ppm_-CF_Fm0.49_Pr81.0_Tm81ResConfus.ppm
// > PrecMoy=[83.93]  FmeasMoy=[0.463]
//
// // > -TESTS-<ipta19> (13 Imgs)
// > Precision:[94.85][85.78][91.79][89.67][86.09][82.35][95.94][96.35][91.26][85.94][87.30][84.01][81.48]
// > Fmeasure:[0.41][0.38][0.41][0.30][0.24][0.45][0.17][0.73][0.43][0.64][0.04][0.39][0.47]
// > PrecMoy=[88.68]  FmeasMoy=[0.389]
//
// //---TESTS-<JOURNAL19> (13 Imgs)  SATHISTO=0.01
// > Precision:[94.22][83.53][89.63][88.22][86.65][81.78][94.56][94.87][88.21][86.24][88.18][83.52][81.50]
// > Fmeasure:[0.48][0.38][0.43][0.31][0.32][0.47][0.25][0.66][0.37][0.65][0.57][0.40][0.49]
// > PrecMoy=[87.78]  FmeasMoy=[0.444]
//
//----------------------------------------------------------
void MCDRIF::DetectionMCD_CONV()
{
  int k,c;
  int nbreg;
  Chrono chrono;

  //>Model-Parameters
  const int NBITERPF=2; 
  const int SzwFlt=9;    
  const int NBITEREM=12; 
  const int SIZEMINREG=40;
  const int   DEPTH=9;
  const float THETA=0.9;
  const float SATHISTO=0.01;  
  
  const int NBCLASS=2;
  const int GAUSSIAN_LAW=1;
  const int VISU_MAT=0;
  
  //>[MemoryAllocation_&_Initialization]
  chrono.reset();
  float*** MatImgBefWBEQ=fmatrix_allocate_3d(TROIS,length,width);
  float*** MatImgAftWBEQ=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgDif1=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgDif2=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgBefFilt=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgAftFilt=fmatrix_allocate_3d(TROIS,length,width);
  float** ImgDif=fmatrix_allocate_2d(length,width);
  float** ConvFilt=fmatrix_allocate_2d(SzwFlt,SzwFlt);
  float** ImgSeg=fmatrix_allocate_2d(length,width); 
  float** ppar=fmatrix_allocate_2d(NBCLASS,TROIS);
  float** ImgHist=fmatrix_allocate_2d(256,256);
  InitZero(ImgDif,length,width);
  for(c=0;c<TROIS;c++) InitZero(ImgDif1[c],length,width);
  for(c=0;c<TROIS;c++) InitZero(ImgDif2[c],length,width);
  InitZero(MatImgTmp1,length,width);
  InitZero(MatImgTmp2,length,width);

  //-------------
  //>---[1]------
  //-------------
  printf("\n [1] _PreProcessing_Step_[%s]",NameImg);
  fflush(stdout);
  for(c=0;c<TROIS;c++) CopyMat(MatImgBefWBEQ[c],MatImgBef[c],length,width);
  for(c=0;c<TROIS;c++) CopyMat(MatImgAftWBEQ[c],MatImgAft[c],length,width);
 
  //-------------
  //>---[2]------
  //-------------
  printf("\n\n [2] _Parameter_Estimation_Step_[%s]",NameImg);

  for(k=0;k<NBITERPF;k++)
     {
      printf("\n\n-------");
      printf("\n-[%d]-",k);
      printf("\n-------");
      
      printf("\n Convolutive_Transformation_Estimation");   
      if (k==0) InitOne(ImgSeg,length,width);
      //InitZero(ImgDif,length,width);    //>>>
      for(c=0;c<TROIS;c++) InitZero(ImgDif1[c],length,width);
      for(c=0;c<TROIS;c++) InitZero(ImgDif2[c],length,width);
      for(c=0;c<TROIS;c++) InitZero(ImgBefFilt[c],length,width);
      for(c=0;c<TROIS;c++) InitZero(ImgAftFilt[c],length,width);

      if ((FlgColorImgB)&&(FlgColorImgA))
      for(c=0;c<TROIS;c++)
	 {
          printf("\n <Channel::%d>",c);
	   
          GradConv(MatImgBefWBEQ[c],MatImgAft[c],ImgSeg,length,width,ConvFilt,SzwFlt);
	  SymPolarPSF(ConvFilt,SzwFlt);  
          VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
          if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
          InfoStatConv(ConvFilt,SzwFlt,SzwFlt);	  
          Conv(MatImgBefWBEQ[c],ImgBefFilt[c],ImgSeg,length,width,ConvFilt,SzwFlt);
          InfoStatMat(ImgBefFilt[c],length,width);	  
          DiffAbs(ImgBefFilt[c],MatImgAft[c],ImgDif1[c],length,width,SzwFlt);
          Recal(ImgDif1[c],length,width);
      
          GradConv(MatImgAftWBEQ[c],MatImgBef[c],ImgSeg,length,width,ConvFilt,SzwFlt);
	  SymPolarPSF(ConvFilt,SzwFlt);  
          VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
          if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
          InfoStatConv(ConvFilt,SzwFlt,SzwFlt);
          Conv(MatImgAftWBEQ[c],ImgAftFilt[c],ImgSeg,length,width,ConvFilt,SzwFlt);
          InfoStatMat(ImgAftFilt[c],length,width);
          DiffAbs(ImgAftFilt[c],MatImgBef[c],ImgDif2[c],length,width,SzwFlt);
          Recal(ImgDif2[c],length,width);
      
	  AddToMatrixMax(ImgDif,ImgDif1,length,width);   
          AddToMatrixMax(ImgDif,ImgDif2,length,width);   
	 }

      else
	{
	  c=0;
	  printf("\n <One Channel>");
	  
          GradConv(MatImgBefWB,MatImgAftWB,ImgSeg,length,width,ConvFilt,SzwFlt);  
	  SymPolarPSF(ConvFilt,SzwFlt);  
          VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
          if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
          InfoStatConv(ConvFilt,SzwFlt,SzwFlt);	  
          Conv(MatImgBefWB,ImgBefFilt[c],ImgSeg,length,width,ConvFilt,SzwFlt);  
          InfoStatMat(ImgBefFilt[c],length,width);	  
          DiffAbs(ImgBefFilt[c],MatImgAftWB,ImgDif1[c],length,width,SzwFlt);
          Recal(ImgDif1[c],length,width);
      
          GradConv(MatImgAftWB,MatImgBefWB,ImgSeg,length,width,ConvFilt,SzwFlt);   
	  SymPolarPSF(ConvFilt,SzwFlt);  
          VisuMatrix(ConvFilt,SzwFlt,SzwFlt);
          if (VISU_MAT) VisuMatrixMatlab(ConvFilt,SzwFlt,SzwFlt);
          InfoStatConv(ConvFilt,SzwFlt,SzwFlt);
          Conv(MatImgAftWB,ImgAftFilt[c],ImgSeg,length,width,ConvFilt,SzwFlt);  
          InfoStatMat(ImgAftFilt[c],length,width);
          DiffAbs(ImgAftFilt[c],MatImgBefWB,ImgDif2[c],length,width,SzwFlt);
          Recal(ImgDif2[c],length,width);
      
          AddToMatrix(ImgDif,ImgDif1[c],length,width);
          AddToMatrix(ImgDif,ImgDif2[c],length,width);
	}

      //::SAVE::
      //SaveImagePpm((char*)"",(char*)"Res-ImgBefFilt",ImgBefFilt,length,width);
      //SaveImagePpm((char*)"",(char*)"Res-ImgAftFilt",ImgAftFilt,length,width);
      
      Recal(ImgDif,length,width);
      RecalImgWithSat(ImgDif,length,width,SATHISTO);
      //::TEST::
      //GaussianFilter(ImgDif,length,width,4);
 
      printf("\n Expectation_Maximization_Estimation");
      ppar[0][0]=ppar[1][0]=0.5;
      ppar[0][2]=ppar[1][2]=100;
      ppar[0][1]=100;
      ppar[1][1]=200;
      EM MyEm(NBCLASS,GAUSSIAN_LAW,length,width);
      MyEm.EM_Estimate(ImgDif,ppar,NBITEREM);
      MyEm.InitMvMatrix(ImgSeg);
      Recal(ImgSeg,length,width);
      NegateMatrix(ImgSeg,length,width);
      FillPictHist(ImgHist,256,ImgDif,length,width,ppar);
      
      //::SAVE::
      //SaveImagePgm((char*)"",(char*)"ResImgHist",ImgHist,256,256);
     }

  //-------------
  //>---[3]------
  //-------------
  printf("\n\n [3] _Segmentation_Step_[%s]",NameImg);
  InitZero(MatImgSegWB,length,width);
  CopyMat(MatImgSegWB,ImgSeg,length,width);
  //::SAVE::
  //SaveImagePgm((char*)"",(char*)"ResImgDif",ImgDif,length,width); 

  SMAP* MySmap=new SMAP(length,width,DEPTH);
  (*MySmap).SMAP_Estimate(ImgDif,ppar,THETA,2,MatImgSegWB); 
  FuseSmallRegions(MatImgSegWB,length,width,&nbreg,SIZEMINREG);
  Recal(MatImgSegWB,length,width);
  //::SAVE::
  //int LgthPyr=(*MySmap).size_bigpicture(DEPTH,length);
  //float** ImgPyr=fmatrix_allocate_2d(LgthPyr,width);
  //(*MySmap).convert_pypmatl_pyrmat((*MySmap).py_pmatl,ImgPyr,DEPTH,length,width);
  //Recal(ImgPyr,LgthPyr,width);
  //(*MySmap).convert_matl_pyrmat(MatImgSegWB,ImgPyr,LgthPyr,length,width);
  //SaveImagePgm((char*)"",(char*)"ResImgPyr",ImgPyr,LgthPyr,width);   
  if (MySmap) delete (MySmap); 

 //-------------
 //>---[4]------
 //-------------
 //>[Result_&_Save]
 printf("\n\n [4]  _Result_Step_[%s]",NameImg);
 printf("\n");
 elptime=chrono.elapsed(SECOND);
 chrono.print();
 float* Result=fmatrix_allocate_1d(4);
 CopyMat(MatImgSeg,MatImgSegWB,length,width);
 ConfusionMatrix(MatImgCon,MatImgSegWB,MatImgGtrWB,length,width,Result);
 fmeasure=FMeasure(MatImgSegWB,MatImgGtrWB,length,width);
 precision=Precis(MatImgSegWB,MatImgGtrWB,length,width);
 sprintf(InfoCD,"%s_%s-CF_Fm%.2f_Pr%.1f_Tm%d",NameImg,MyCom,fmeasure,precision,elptime);
 
 //::SAVE::
 //SaveImagePgm(InfoCD,(char*)"ResDif",ImgDif,length,width);
 SaveImagePgm(InfoCD,(char*)"ResSeg",MatImgSegWB,length,width);
 SaveImagePpm(InfoCD,(char*)"ResConfus",MatImgCon,length,width); 
    
  //>FreeMemory_&_End
  if (MatImgBefWBEQ) free_fmatrix_3d(MatImgBefWBEQ,TROIS);
  if (MatImgAftWBEQ) free_fmatrix_3d(MatImgAftWBEQ,TROIS);
  if (ImgDif1) free_fmatrix_3d(ImgDif1,TROIS);
  if (ImgDif2) free_fmatrix_3d(ImgDif2,TROIS);
  if (ImgBefFilt) free_fmatrix_3d(ImgBefFilt,TROIS);
  if (ImgAftFilt) free_fmatrix_3d(ImgAftFilt,TROIS);
  if (ConvFilt) free_fmatrix_2d(ConvFilt);
  if (ImgSeg) free_fmatrix_2d(ImgSeg);
  if (ImgDif) free_fmatrix_2d(ImgDif); 	 
  if (ppar)       free_fmatrix_2d(ppar);
  if (ImgHist)    free_fmatrix_2d(ImgHist);
  printf("\n\n [END]\n");
}






  
  

  

  

  

